From asgard!barrett@boulder.Colorado.EDU Thu Mar 21 22:59:17 1991
Received: from relay1.UU.NET by uunet.uu.net with SMTP 
	(5.61/UUNET-primary-gateway) id AA29688; Thu, 21 Mar 91 22:58:58 -0500
Received: from boulder.Colorado.EDU by relay1.UU.NET with SMTP 
	(5.61/UUNET-shadow-mx) id AA22668; Thu, 21 Mar 91 22:58:14 -0500
Received: from asgard.UUCP by boulder.Colorado.EDU with UUCP id AA14014
  (5.65+/cu-ida-1.3.5 for postmaster@uunet.uu.net); Thu, 21 Mar 91 20:52:50 -0700
Message-Id: <9103220352.AA14014@boulder.Colorado.EDU>
Received: by asgard
	(15.11/15.6) id AA07292; Thu, 21 Mar 91 20:19:50 mst
Status: OR
From: Dave Barrett <asgard!barrett@boulder.Colorado.EDU>
To: postmaster@uunet.uu.net
Subject: Re:  Software contributions
Date: Thu, 21 Mar 91 20:19:50 mst

What is have is a Fast DES-compatible encipherment program including
stuff for sending through mail, multiple encryption, and good key hashing
methods.

Here is the submission.  Unshar it and read the README file.  The man
page is also there.  If you decide it's worth the trouble, let me know.

Thanks.

Dave Barrett
barrett@boulder.Colorado.EDU
-------

# This is a shell archive.  Remove anything before this line,
# then unpack it by saving it in a file and typing "sh file".
#
# Wrapped by barrett at asgard on Sun Mar 17 17:12:43 1991
#
# This archive contains:
#	README		Makefile	cipher.h	des.h		
#	desdefs.h	cipher.c	descfb.c	deskey.c	
#	desblock.c	sboxp.c		getkey.c	destest.c	
#	desvalid.c	testcfb.c	cipher.1	cmail		
#	testdata.des	testin.cfb	testout.cfb	testin		
#	testout		atob.c		btoa.1		btoa.c		

echo x - README
cat >README <<'@EOF'
This package is a DES-compatible encipherement package which makes it easy
to send and receive secret mail through electronic mailers.  

The most interesting products are:
   cipher (decipher) - the actual encipherment/decipherment program.
   cipher.1	     - the nroff compatible manual page for cipher (please read)
   atob, btoa	     - Binary to ASCII converters from compress 4.0 package
   cmail	     - A script to interface above with your mailer

To install:

Edit the Makefile:
   Define -DBSD or not as appropriate
   Change MANDIR and BINDIR as appropriate

Type "make"

   You may get some compiler warnings about & in front of arrays, invalid
   pointer combinations and optimization problems.  These are OK.  The
   important thing is too see if the testsuite passes.  If it does, the
   make will terminate normally.

Type "make install"

   You may want to read about the "~|" option to the BSD mailer and compose
   "encr" and "decr" scripts.

Send bug reports to "barrett%asgard@boulder.Colorado.EDU"
@EOF

chmod 644 README

echo x - Makefile
cat >Makefile <<'@EOF'
#
# Change the CFLAGS and MANDIR and BINDIR to suit your machine.
#
# Type "make" to build and test.
# Type "make -n install" to see how to install the code
#
# use -DBSD for Berkley systems

#default C compiler
#CC=cc
CFLAGS=-O -DBSD
LDFLAGS=-O

#gnu C compiler
#CC=gcc
#CFLAGS=-O -Wall 

MANDIR=/usr/local/man/man1
BINDIR=/usr/local/bin

# no changes needed below this line

# atob and btoa are exact copies from the compress4.0 distribution
AUXSRC=atob.c btoa.1 btoa.c
AUXEXE=atob btoa

SRC=README Makefile	\
	cipher.h des.h desdefs.h \
	cipher.c descfb.c deskey.c desblock.c sboxp.c getkey.c \
	destest.c desvalid.c testcfb.c \
	cipher.1 cmail\
	testdata.des testin.cfb testout.cfb testin testout \
	$(AUXSRC)

all:		cipher test $(AUXEXE)

cipher:		cipher.o getkey.o deskey.o desblock.o sboxp.o descfb.o 
		$(CC) $(LDFLAGS) -o $@ $@.o getkey.o deskey.o \
		desblock.o sboxp.o descfb.o 

decipher:	cipher
		ln cipher decipher

desvalid:	desvalid.o desblock.o sboxp.o
		$(CC) $(LDFLAGS) -o $@ $@.o desblock.o sboxp.o

destest:	destest.o desblock.o
		$(CC) $(LDFLAGS) -o $@ $@.o desblock.o sboxp.o

testcfb:	testcfb.o descfb.o desblock.o sboxp.o
		$(CC) $(LDFLAGS) -o $@ $@.o descfb.o desblock.o sboxp.o

cipher.o:	cipher.h des.h

cipher.man:	cipher.1
		nroff -man <cipher.1 | col -b >cipher.man

atob:		atob.o
		$(CC) $(LDFLAGS) -o $@ $@.o

btoa:		btoa.o
		$(CC) $(LDFLAGS) -o $@ $@.o

despass:	despass.o desblock.o sboxp.o
		$(CC) $(LDFLAGS) -o $@ $@.o desblock.o sboxp.o

uxpass:		uxpass.o
		$(CC) $(LDFLAGS) -o $@ $@.o

despass.o:	cipher.h des.h
descfb.o:	des.h
deskey.o:	des.h
sboxp.o:	desdefs.h

desblock.o:	desblock.s
		$(CC) $(CFLAGS) -c desblock.s

desblock.s:	desblock.c desdefs.h
		$(CC) $(CFLAGS) -S desblock.c

time:		cipher
		time cipher -i00 -x00 <testin3 >x

gprof: 		time
		gprof -b cipher >gprof.out

test:		destest desvalid testdata.des cipher decipher testcfb testin.cfb
		@echo des subroutine Tests
		desvalid -v < testdata.des
		destest -v
		@echo desCFB subroutine Tests with varying block sizes
		testcfb -s 1 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 2 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 3 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 4 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 5 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 9 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 15 <testin.cfb >x; cmp x testout.cfb
		testcfb -s 17 <testin.cfb >x; cmp x testout.cfb
		@rm x
		@echo cipher program Tests -- single encipherment
		cipher -x0123456789abcdef -i1234567890abcdef <testin.cfb >x
		cmp testout.cfb x
		cipher -d -x0123456789abcdef -i1234567890abcdef <x >y
		cmp testin.cfb y
		cipher -k bigtestkey <testin >x; cmp testout x
		cipher -d -k bigtestkey <x >y; cmp testin y
		@echo Multiple encipherment
		decipher -k test <testin | cipher -k test >x; cmp x testin
		cipher -k "phartles and" -k "jaymes beer" <testin >x
		cipher -d -k "jaymes beer" -k "phartles and" <x >y
		cmp testin y
		decipher -ek "phartles and" <testin | cipher -k "jaymes beer" >z
		cmp x z
		@echo Mixed triple encryption
		cipher -ek k1 -dk k2 -ek k3 <testin >x
		cipher -dk k3 -ek k2 -dk k1 <x >y; cmp testin y
		decipher -k k3 <x | cipher -k k2 | decipher -k k1 >z
		cmp testin z
		@rm x y z
		@echo "Expect 16 weak key warnings:"
		@cipher -xe001e001f101f101 </dev/null >/dev/null
		@cipher -x01e001e001f101f1 </dev/null >/dev/null
		@cipher -xfe1ffe1ffe0efe0e </dev/null >/dev/null
		@cipher -x1ffe1ffe0efe0efe </dev/null >/dev/null
		@cipher -xe01fe01ff10ef10e </dev/null >/dev/null
		@cipher -x1fe01fe00ef10ef1 </dev/null >/dev/null
		@cipher -x01fe01fe01fe01fe </dev/null >/dev/null
		@cipher -xfe01fe01fe01fe01 </dev/null >/dev/null
		@cipher -x011f011f010e010e </dev/null >/dev/null
		@cipher -x1f011f010e010e01 </dev/null >/dev/null
		@cipher -xe0fee0fef1fef1fe </dev/null >/dev/null
		@cipher -xfee0fee0fef1fef1 </dev/null >/dev/null
		@cipher -x0101010101010101 </dev/null >/dev/null
		@cipher -xfefefefefefefefe </dev/null >/dev/null
		@cipher -xe0e0e0e0f1f1f1f1 </dev/null >/dev/null
		@cipher -x1f1f1f1f0e0e0e0e </dev/null >/dev/null

install:	cipher cipher.1 $(AUXEXE)
		cp cipher $(BINDIR)
		ln $(BINDIR)/cipher $(BINDIR)/decipher
		cp cipher.1 $(MANDIR)
		cp btoa atob $(BINDIR)
		cp btoa.1 $(MANDIR)
		ln $(MANDIR)/btoa.1 $(MANDIR)/atob.1

tar:		$(SRC)
		tar -cvf - $(SRC) | compress >cipher.tar.Z

shar:		$(SRC)
		shar $(SRC) >cipher.shar

arc:		cipher.lzh

cipher.lzh:	$(SRC)
		lharc c cipher.lzh $(SRC)

clean:
		rm -f cipher.o desvalid.o destest.o testcfb.o
		rm -f desblock.s desblock.o sboxp.o getkey.o descfb.o deskey.o
		rm -f btoa.o atob.o
		rm -f despass.o uxpass.o

clobber: 	clean
		rm -f cipher decipher destest desvalid testcfb
		rm -f atob btoa
		rm -f despass uxpass
		rm -f $(AUXEXE)
@EOF

chmod 644 Makefile

echo x - cipher.h
cat >cipher.h <<'@EOF'
/* 
 * Data encription standard header file for cipher.c
 */
#include "des.h"

#define makeKey		desMakeKey
#define encipher	des
#define decipher	des
#define	inBlockSize	desInBlockSize
#define	outBlockSize	desOutBlockSize
@EOF

chmod 444 cipher.h

echo x - des.h
cat >des.h <<'@EOF'
#define DES_BLOCKSIZE	8
#define MAXKEYLEN 	DES_BLOCKSIZE

#ifdef mips
typedef char *keyType;		/* mips won't recognize keyType x for void * */
#else
typedef void *keyType;
#endif

#ifndef __STDC__
extern void desMakeKey();
extern void des();
extern int  desInBlockSize(); 
extern int  desOutBlockSize(); 

/* From descfb.c */
extern unsigned desCFB();
extern void	desXor();
/* From deskey.c */
extern void 	desKey();
extern void	desStrMAC();
#else
extern void desMakeKey(keyType *key, char *keystr, unsigned size, int decrFlag);
extern void des(char *dst, char *src, keyType key);
extern int  desInBlockSize(keyType); 
extern int  desOutBlockSize(keyType); 

/* From descfb.c */
extern unsigned desCFB(
   char *dst, char *src, unsigned size, 
   char *iv, unsigned ivsize, keyType key, int decr
);
extern void desXor(char *dst, char *src0, char *src1, unsigned size);

/* from deskey.c */
extern void desKey(char *keybits, char *str, int pad);
extern void 
   desStrMac(char *mac, char *src, unsigned len, char pad, keyType key);
#endif
@EOF

chmod 444 des.h

echo x - desdefs.h
cat >desdefs.h <<'@EOF'
#define BLOCKBITS	64		/* bits per block */
#define KEYBITS		56		/* bits per key */
#define STAGECOUNT	16		/* number of stages */
#define DES_BLOCKSIZE	8		/* bytes per block */

#define BASE		1		/* a kludge for 0 vs 1 arrays */

typedef unsigned char  u8;
typedef unsigned short u16;
typedef	unsigned long  u32;
typedef		 long  s32;

typedef u8	bit;			/* 1 bit quantity */
typedef u8	u4;			/* 4 bit quantity */
typedef u8	u6;			/* 6 bit quantity */

typedef u8 	blockBitIndex;		/* 1..BLOCKBITS */
typedef u8	keyBitIndex;		/* 1..KEYBITS */

typedef blockBitIndex	bitIndex;	/* generic index into a bitVector */
typedef bitIndex	bitIndexVector[];	/* a vector of bit indices */

typedef	bit		blockType[BLOCKBITS];

typedef struct {
   u32		left;				/* Lowest address = bit 1 */
   u32		right;				/* Highest address = bit 64 */
} desPair;

typedef	u6		u6Block[8];		/* Optimization 6 */

#ifndef NEWDES
typedef	u6Block		keyVector[STAGECOUNT];	/* Optimization 6 */
#else
typedef	desPair		keyVector[STAGECOUNT];	/* Optimization 6 */
#endif

typedef	u4		stageRange;		/* 1..STAGECOUNT */

typedef union {
   desPair	pair;
   u8 		bytes[8];			/* 0 = LSB, 7 = MSB */
} desUnion;

typedef struct {
   u8		decr;			/* encrypt, decrypt flag */
   keyVector 	bits;
} desKeyType;

extern u32 sBoxp[8][64];
@EOF

chmod 444 desdefs.h

echo x - cipher.c
cat >cipher.c <<'@EOF'
/*
 * cipher - a more secure replacement for UNIX crypt program 
 *
 * Generic block encipherment/decipherment program 
 * modified specifically for the Data Encryption Standard using
 * Cipher Block Feedback (CFB) mode as described in FIPS pub 81.
 *
 * See also FIPS PUB 74.
 *
 * Permission is given copy and use this program provided it is not sold
 * for profit.
 *
 * Written by David A. Barrett (barrett%asgard@boulder.Colorado.EDU)
 */
#include <stdio.h>
#include <string.h>
#include "cipher.h"

extern int errno;
extern char *sys_errlist[];
extern int sys_nerr;

extern int optind;
extern char *optarg;

#ifdef __STDC__
extern int getkey(char *, char *, unsigned);
#else
extern int getkey();
#endif

#ifdef MSDOS
#define PATHCHAR '\\'
#else
#define PATHCHAR '/'
#endif

static char ident[] = 
" @(#) cipher.c  version 2.01 26-Feb-91 by Dave Barrett\n";
static char rcsIdent[] = 
" @(#) cipher.c  $Revision: 1.5 $ $Date: 91/01/23 12:11:11\n";

#define	IO_BUFSIZE	1024		/* small for data cache speed */
#define MAXCIPHER	10		/* maximum multiple encipherments */
#define KEYBUFLEN	129		/* allow long keys */

typedef struct {
   char	   iv[DES_BLOCKSIZE];
   keyType key;
   int	   ivlen;
   int	   decr;
} KeyItem;

KeyItem keys[MAXCIPHER];
char    bufs[2][IO_BUFSIZE];
char    *progName;

typedef char block[DES_BLOCKSIZE];

/*
 * Keys which could accidently reproduce the plaintext with multiple-encryption
 */
block badKeys[16] = {
   { 0xe0, 0x00, 0xe0, 0x00, 0xf0, 0x00, 0xf0, 0x00 },
   { 0x00, 0xe0, 0x00, 0xe0, 0x00, 0xf0, 0x00, 0xf0 }, 
   { 0xfe, 0x1e, 0xfe, 0x1e, 0xfe, 0x0e, 0xfe, 0x0e },
   { 0x1e, 0xfe, 0x1e, 0xfe, 0x0e, 0xfe, 0x0e, 0xfe }, 
   { 0xe0, 0x1e, 0xe0, 0x1e, 0xf0, 0x0e, 0xf0, 0x0e },
   { 0x1e, 0xe0, 0x1e, 0xe0, 0x0e, 0xf0, 0x0e, 0xf0 }, 
   { 0x00, 0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00, 0xfe },
   { 0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00, 0xfe, 0x00 },
   { 0x00, 0x1e, 0x00, 0x1e, 0x00, 0x0e, 0x00, 0x0e },
   { 0x1e, 0x00, 0x1e, 0x00, 0x0e, 0x00, 0x0e, 0x00 }, 
   { 0xe0, 0xfe, 0xe0, 0xfe, 0xf0, 0xfe, 0xf0, 0xfe },
   { 0xfe, 0xe0, 0xfe, 0xe0, 0xfe, 0xf0, 0xfe, 0xf0 }, 
   { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 },	/* self-dual */
   { 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe },	/* self-dual */
   { 0xe0, 0xe0, 0xe0, 0xe0, 0xf0, 0xf0, 0xf0, 0xf0 },	/* self-dual */
   { 0x1e, 0x1e, 0x1e, 0x1e, 0x0e, 0x0e, 0x0e, 0x0e },	/* self-dual */
};

/*
 * Return nonzero if the key is one of the well-known "weak" keys (FIPS Pub 74)
 */
int weakKey(keybits)
   char *keybits;
{
   register block *keyp = &badKeys[0];		/* common compiler bug here */
   register unsigned count = sizeof(badKeys) / sizeof(badKeys[0]);
   register unsigned i;

   do {
      for (i = 0; i < DES_BLOCKSIZE; i++) {
	 if ((((*keyp)[i] ^ keybits[i]) & 0xfe) != 0) goto notfound;
      }
      break;
notfound:
      keyp++;
   } while (--count != 0);
   return count;
}

int hexdigit(ch)
   register char ch;
{
   if (ch >= '0' && ch <= '9') return ch - '0';
   if (ch >= 'a' && ch <= 'f') return ch - 'a' + 10;
   if (ch >= 'A' && ch <= 'F') return ch - 'A' + 10;
   return -1;
}

/*
 * Convert an ASCII hexadecimal number to it's corresponding string of bytes
 */
unsigned hex(d, s, size)
   register char *d, *s;
   register unsigned size;
{
   register unsigned count = 0;
   register int lo, hi;

   if (size > 0) do {
      hi = hexdigit(*s++);
      if (hi < 0) break;
      lo = hexdigit(*s++);
      if (lo < 0) break;
      *d++ = (hi << 4) | lo;
      count++;
   } while (count < size);
   return count;
}

/*
 * Because we are using CFB, we always encrypt.  Since we'd like to be
 * able to run the chips in either mode, perhaps CBC would be better.
 * If CBC is used though, the last block must be handled in OFB mode.  Sigh.
 *
 * Returns:  
 *  -1 - out of memory (program exits, and error reported)
 *   0 - success
 *   1 - key is a weak key
 */
int setKey(kp, keybits, keystr, mode)
   register keyType *kp;
   char *keybits, *keystr;
   int  mode;
{
   register int res;

   if (keystr != (char *) 0) {
      desKey(keybits, keystr, ' ');		/* space padded */
      memset(keystr, '\0', strlen(keystr));	/* blank out key asap */
   }

   res = weakKey(keybits);

   makeKey(kp, keybits, DES_BLOCKSIZE, mode);	/* 0 means encrypt mode */
   memset(keybits, '\0', DES_BLOCKSIZE);	/* zero out bits asap */

   if (*kp == (keyType) 0) {
      fprintf(stderr, "%s: couldn't allocate memory for encryption key\n",
	 progName);
      exit(1);
   }
   return res;
}

int main(argc, argv)
   int argc;
   char *argv[];
{
   int 	    i, ch, rcount, wcount; 
   int	    ivcount = 0, keycount = 0, decrcount = 0, ciphercount = 1;
   int      checkkey = 1, keystrlen = 0, keylen = 0;
   char	    *chp, *ibuf = bufs[1], *obuf = bufs[0];
   char     keybits[DES_BLOCKSIZE], ivbits[DES_BLOCKSIZE];
   char	    keybuf[KEYBUFLEN], chkbuf[KEYBUFLEN], ivbuf[DES_BLOCKSIZE];
   KeyItem  *kip;

   progName = *argv;
   if ((chp = strrchr(progName, PATHCHAR)) != (char *) 0) progName = chp+1;

   if (strcmp(progName, "decipher")==0 || strcmp(progName, "decrypt")==0)  {
      keys[decrcount].decr = 1;
   } else {
      keys[decrcount].decr = 0;
   }

   while ((ch = getopt(argc, argv, "devni:k:x:")) != EOF) switch (ch) {
   case 'd':  
      if (decrcount == MAXCIPHER) goto cipherError;
      keys[decrcount++].decr = 1;		/* decrypt */
      break;
   case 'e':  
      if (decrcount == MAXCIPHER) goto cipherError;
      keys[decrcount++].decr = 0;		/* encrypt */
      break;
   case 'i':					/* initialization vector */
      if (ivcount == MAXCIPHER) goto cipherError;
      memset(ivbits,  '\0', DES_BLOCKSIZE);		/* pad iv  with '\0' */
						/* default IV is zero */
      i  = hex(ivbuf, optarg, DES_BLOCKSIZE);	/* right-justified */
      memcpy(ivbits + DES_BLOCKSIZE - i, ivbuf, i);
      memcpy(keys[ivcount++].iv, ivbits, DES_BLOCKSIZE);
      break;
   case 'x':					/* key in hexadecimal */
      if (keycount == MAXCIPHER) goto cipherError;
      memset(keybits, '\0', DES_BLOCKSIZE);		/* pad key with '\0' */
      keylen = hex(keybits, optarg,DES_BLOCKSIZE);	/* left-justified */
      i = setKey(&keys[keycount++].key, keybits, (char *) 0, 0);
      goto chkKey;
   case 'k':  					/* key as a string */
      if (keycount == MAXCIPHER) goto cipherError;
      i = setKey(&keys[keycount++].key, keybits, optarg, 0);
chkKey:
      if (i) {
	 fprintf(stderr, "%s: warning -- weak key selected\n", progName);
      }
      break;
   case 'v':
      checkkey++;
      break;
   case 'n':
      --checkkey;
      break;
   case '?':
   default:
usage:
      fprintf(stderr, 
"usage: %s [ -v|n ] {-de} {-i hex_initvec } {-x hex_key } {-k keystring }\n", 
      progName);
      return 1;
cipherError:
      fprintf(stderr, 
      "%s: can't exceed %d multiple-encipherments\n", progName, MAXCIPHER);
      return 1;
   }
   argc -= optind;
   argv += optind;

   if (argc != 0) goto usage;
   if (decrcount == 0) decrcount++;

   if (decrcount > ciphercount) ciphercount = decrcount;
   if (ivcount   > ciphercount) ciphercount = ivcount;
   if (keycount  > ciphercount) ciphercount = keycount;

   while (decrcount < ciphercount) keys[decrcount++].decr = keys[0].decr;
   while (ivcount < ciphercount) {			/* default IV = 0 */
      keys[ivcount].ivlen = DES_BLOCKSIZE;
      memset(keys[ivcount++].iv, '\0', DES_BLOCKSIZE);
   }

   while (keycount < ciphercount) {		   /* must input all keys */
      keystrlen = getkey("Input Key:", keybuf, KEYBUFLEN-1);
keyRetry:
      if (keystrlen <= 0) {
	 fprintf(stderr, "%s: couldn't get key\n", progName);
	 return 1;
      }
      if (checkkey) {
	 i = getkey("Verify Key:", chkbuf, KEYBUFLEN-1);
	 if (i != keystrlen || memcmp(chkbuf, keybuf, i) != 0) {
	    keystrlen = getkey("Keys didn't match; try again\r\nInput Key:", 
	       keybuf, KEYBUFLEN-1);
	    goto keyRetry;
	 }
	 memset(chkbuf, '\0', i);
      }
      keybuf[keystrlen] = '\0';
      i = setKey(&keys[keycount].key, keybits, keybuf, 0);
      if (i) {
	 keystrlen = 
	    getkey("Weak key generated; use another one\r\nInput Key:",
	       keybuf, KEYBUFLEN-1);
	 goto keyRetry;
      }
      keycount++;
   }

   do {
      rcount = read(0, obuf, IO_BUFSIZE);
      if (rcount <= 0) break;

      i = ciphercount;
      kip = keys;
      do {
	 chp = obuf; obuf = ibuf; ibuf = chp;
	 kip->ivlen = desCFB(
	    obuf, ibuf, rcount, kip->iv, kip->ivlen, kip->key, kip->decr);
	 kip++;
      } while (--i != 0);

      wcount = write(1, obuf, rcount);
   } while (wcount == rcount);

   if (rcount < 0) {
      fprintf(stderr, "%s: read failed: %s\n", progName, sys_errlist[errno]);
      return 3;
   }
   if (rcount != 0 && rcount != wcount)  {
      fprintf(stderr, "%s: write failed: %s\n", progName, sys_errlist[errno]);
      return 2;
   }

   return 0;
}
@EOF

chmod 444 cipher.c

echo x - descfb.c
cat >descfb.c <<'@EOF'
#include <string.h>
#include "des.h"

/*
 * Data Encryption Standard: 64-bit cipher-feedback mode encryption/decryption
 *
 * Note:  destination and source may overlap for encryption but not decryption
 *
 * To create a message authentication code (MAC):
 * The returned iv from the final call to either CFB routine should be 
 * passed to the DES function.  The leftmost (most significant) n-bits may 
 * be used as the MAC.  Deciphering the ciphertext will produce the same
 * MAC as enciphering the plaintext.  This is the method used in FIPS
 * Pub 81, with 64-bit CFB mode, with the last block shifted in by the
 * number of bits it contains.
 *
 * If compatability with FIPS Publication 113 is desired, the input data
 * should be padded with zeros until it is a multiple of 8 bytes.  Then, the
 * iv should be set to the first eight bytes of the input data, and the
 * remaining bytes enciphered (or ciphertext deciphered).  Then use the
 * final iv as above.  
 *
 * Written by: David A. Barrett (barrett%asgard@boulder.Colorado.EDU)
 */
void desXor(d, s, x, count)
   register char *d, *s, *x;
   register unsigned count;
{
   if (count != 0) do {
      *d++ = *s++ ^ *x++;
   } while (--count != 0);
}

/*
 * Encipher/decipher a block of memory using cipher-feedback mode
 *
 * Input:
 *    dst, src, size = destination and source addresses and their size in bytes
 *    iv     = initialization vector  (right-justified 0 padded on 1st call)
 *    ivsize =  number of bytes in iv (should be DES_BLOCKSIZE on 1st call)
 *    decr   =  non-zero for decryption, zero for encryption
 *
 * Output:
 *    iv     = the next initialization vector
 *    ivsize = The size of the next initialization vector
 */
unsigned desCFB(dst, src, size, iv, ivsize, key, decr)
   register char     *dst, *src, *iv;
   register unsigned size, ivsize; 
   keyType 	     key;
   int		     decr;
{
   register char *inp = dst;

   if (decr) inp = src; 

   if (ivsize != DES_BLOCKSIZE) {
      if (size < ivsize) {
	 desXor(dst, iv, src, size);
	 memcpy(iv, iv + size, DES_BLOCKSIZE - size);
	 memcpy(iv + DES_BLOCKSIZE - size, inp, size);
	 return ivsize - size;
      }
      desXor(dst, iv, src, ivsize);
      memcpy(iv, iv + ivsize, DES_BLOCKSIZE - ivsize);
      memcpy(iv + DES_BLOCKSIZE - ivsize, inp, ivsize);
      dst  += ivsize;
      src  += ivsize;
      inp  += ivsize;
      size -= ivsize;
   }

   if (size != 0) {
      des(iv, iv, key);
   }
   if (size > DES_BLOCKSIZE) do {
      desXor(dst, iv, src, DES_BLOCKSIZE);
      des(iv, inp, key);
      dst  += DES_BLOCKSIZE;
      src  += DES_BLOCKSIZE;
      inp  += DES_BLOCKSIZE;
      size -= DES_BLOCKSIZE;
   } while (size > DES_BLOCKSIZE);

   ivsize = DES_BLOCKSIZE - size;

   desXor(dst, iv, src, size);
   memcpy(iv, iv + size, ivsize);		/* shift DES left */
   memcpy(iv + ivsize, inp, size);		/* shift in input */

   return ivsize;
}
@EOF

chmod 444 descfb.c

echo x - deskey.c
cat >deskey.c <<'@EOF'
/*
 * String to key transformation based upon:
 *
 *    FIPS Pub 112: "Password Usage" 1985 May 30.
 *
 * Written by David A. Barrett	(barrett@boulder.Colorado.EDU)
 */
#include "des.h"
#include "string.h"

/*
 * Compute a Message Authentication code according to 
 *    FIPS Pub 113: "Computer Data Authentication" 1985 May 30
 * 
 * Uses DES in CBC mode with IV = 0, input string padded on right with <pad> 
 * to positive multiple of DES_BLOCKSIZE bytes.
 *    set pad = '\0' for FIPS Pub 113.
 *    set pad = ' '  for FIPS Pub 112.
 */
void desStrMAC(mac, src, len, pad, key)
   register char *mac, *src;
   register unsigned len;
   char pad;
   keyType key;
{
   char buf[DES_BLOCKSIZE];

   memset(mac, '\0', DES_BLOCKSIZE);			/* IV */

   if (len > DES_BLOCKSIZE) do {
      desXor(mac, mac, src, DES_BLOCKSIZE);
      des(mac, mac, key);
      src += DES_BLOCKSIZE;
      len -= DES_BLOCKSIZE;
   } while (len > DES_BLOCKSIZE);

   memcpy(buf, src, len);	/* len can be 0 or DES_BLOCKSIZE */
   memset(buf + len, pad, DES_BLOCKSIZE - len);
   desXor(mac, mac, buf, DES_BLOCKSIZE);
   des(mac, mac, key);
}

/*
 * Shift each byte in a block of memory left by one bit
 *
 * Used because ASCII has high bit clear, and DES ignores low bit.
 */
void setkeybits(d, s, count)
   register char *d, *s;
   register unsigned count;
{
   if (count != 0) do {
      *d++ = *s++ << 1;			/* ignore hi bit, clear lo bit */
   }  while (--count != 0);
}

/*
 * Convert an ASCII string of arbitrary length to an 8-byte key suitable as an 
 * input key for the DES.
 *
 * The string is padded on the right with <pad> to a multiple of 8 characters.
 * The minimim length of the resulting string will be 16 characters.
 * A key is computed by using the first 8 characters of the string, each
 * character left-shifted by one bit.  This key is used to encipher the
 * remaining characters of the string using the DES in CFB mode, IV = 0,
 * to compute a Message Authentication Code ala FIPS PUB 113.
 *
 * For input strings of 8 or fewer characters, this will result in the
 * DES encryption of the string consisting of 8 <pad> characters.  FIPS
 * Pub 112 used the space character for <pad>.
 *
 * Note: Unlike fips Pub 112, this algorithm does not restrict the output
 * bits to be an 8 character string consisting of the printable ASCII
 * characters.  The string is returned as 8 chararcters of 8-bits each.
 * No parity is computed.
 */
void desKey(keybits, str, pad)
   char *keybits;
   char *str;
   int pad;
{
   register unsigned len = strlen(str);
   unsigned     keysize = len;
   keyType 	key = (keyType) 0;

   if (keysize > DES_BLOCKSIZE) keysize = DES_BLOCKSIZE;

   setkeybits(keybits, str, keysize);		/* key */
   memset(keybits + keysize, pad << 1, DES_BLOCKSIZE - keysize);
   str += keysize;
   len -= keysize;

   desMakeKey(&key, keybits, DES_BLOCKSIZE, 0);		/* encryption mode */
   desStrMAC(keybits, str, len, pad, key);
   free(key);
}
@EOF

chmod 444 deskey.c

echo x - desblock.c
cat >desblock.c <<'@EOF'
/*
 * A Fast software implementation of...
 *
 * the National Bureau of Standards Data Encryption Standard
 *
 * From Federal Information Processing Standards Publication 46-1, 22-Jan-88
 *
 * Written by David A. Barrett (barrett%asgard@boulder.Colorado.EDU)
 *
 * Permission is given for all purposes other than selling code based
 * upon optimizations presented here.
 */
#include <string.h>
#include "desdefs.h"			/* private data structures */

static char ident[] = 
   " @(#) desblock.c  version 1.00 23-Jan-91 by Dave Barrett\n";
static char rcsIdent[] = 
   " @(#) desblock.c  RCS: $Revision: 1.2 $ $Date: 91/02/21 00:29:08 $\n";

/*
 * The sum of all elements must be KEYBITS
 */
keyBitIndex keyRotates[STAGECOUNT] = {
   1, 1, 2, 2, 2, 2, 2, 2,
   1, 2, 2, 2, 2, 2, 2, 1,
};

/*
 * Permuted Choice 1: (PC-1)
 *
 * used only once to permute key  (64-bit to 56-bit permutation)
 * Ignores bits =   mod 8 (used as ascii parity bits)
 */
blockBitIndex keyTr1[KEYBITS] = {
   57, 49, 41, 33, 25, 17,  9,  1,
   58, 50, 42, 34, 26, 18, 10,  2,
   59, 51, 43, 35, 27, 19, 11,  3,
   60, 52, 44, 36, 			/* this missing chunk down below */
   63, 55, 47, 39, 31, 23, 15,  7, 
   62, 54, 46, 38, 30, 22, 14,  6,
   61, 53, 45, 37, 29, 21, 13,  5,
                   28, 20, 12,  4
};

#if 0
/*
 * debug 
 */
void showBits(vec, size)
   register bit *vec;
   int size;
{
   register bit *end = vec + size;
   int i;

   for (i = 0; i < size; i++) {
      printf("%d", i % 10);
   }
   putchar('\n');
   do {
      printf("%d", *vec++);
   } while (vec < end);
   putchar('\n');
}
#endif

void rotateLeft(x, size)
   bit *x;
   bitIndex  size;
{
   register bit i = x[0];

   memcpy(x, x + 1, size-1);	/* should be memove, but should work */
   x[size-1] = i;
}

void transpose(dst, src, dstSize, srcSize, perm)
   bit 	 	  *src;
   bit		  *dst;
   bitIndex 	  dstSize, srcSize;
   bitIndexVector perm;
{
   bit 	x[BLOCKBITS+BASE];
   register bit *dp = dst + dstSize;
   register bit *pp = perm + dstSize;

   memcpy(x + BASE, src, srcSize * sizeof src[0]);
   do {
      *--dp = x[*--pp];
   } while (pp > perm);
}

/*
 * Optimization 6: key2Transpose (56 to 48 bit permuted choice with packing)
 */
void key2Transpose(d, s)
   register u6  *d;
   register bit *s;
{
   register u6 i;

   i =s[13]; i<<=1; i|=s[16]; i<<=1; i|=s[10]; i<<=1; 
   i|=s[23]; i<<=1; i|=s[0];  i<<=1; i|=s[4]; 
   *d++=i; 
   i =s[2];  i<<=1; i|=s[27]; i<<=1; i|=s[14]; i<<=1; 
   i|=s[5];  i<<=1; i|=s[20]; i<<=1; i|=s[9];  
   *d++=i; 
   i =s[22]; i<<=1; i|=s[18]; i<<=1; i|=s[11]; i<<=1; 
   i|=s[3];  i<<=1; i|=s[25]; i<<=1; i|=s[7]; 
   *d++=i; 
   i =s[15]; i<<=1; i|=s[6];  i<<=1; i|=s[26]; i<<=1; 
   i|=s[19]; i<<=1; i|=s[12]; i<<=1; i|=s[1]; 
   *d++=i; 
   i =s[40]; i<<=1; i|=s[51]; i<<=1; i|=s[30]; i<<=1; 
   i|=s[36]; i<<=1; i|=s[46]; i<<=1; i|=s[54]; 
   *d++=i; 
   i =s[29]; i<<=1; i|=s[39]; i<<=1; i|=s[50]; i<<=1; 
   i|=s[44]; i<<=1; i|=s[32]; i<<=1; i|=s[47]; 
   *d++=i; 
   i =s[43]; i<<=1; i|=s[48]; i<<=1; i|=s[38]; i<<=1; 
   i|=s[55]; i<<=1; i|=s[33]; i<<=1; i|=s[52]; 
   *d++=i; 
   i =s[45]; i<<=1; i|=s[41]; i<<=1; i|=s[49]; i<<=1; 
   i|=s[35]; i<<=1; i|=s[28]; i<<=1; i|=s[31]; 
   *d=i; 
}

/* 
 * Convert a key block to a bit vector
 *
 * dst - the destination address
 * src - the source address
 */
bit *unpackKeyBlock(dst, src)
   register bit *dst;
   register u8  *src;
{
   register u8   b;
   register unsigned c0;
   register unsigned c1;

   c1 = 8;
   dst -= 8;				/* new */
   do {
      dst += 16;			/* new */
      b    = *src++;
      c0   = 8;
      do {
	 *--dst = b & 1;		/* was *dst++ */
	 b >>= 1;
      } while (--c0 != 0);
   } while (--c1 != 0);
   return dst + 8;
}

/*
 * Given a key string, produce a key suitable for encryption, decryption
 *
 * On input, key must be initialized to 0 or a pointer to adequate storage
 *
 * Set decr to 1 for decryption, 0 for encryption
 */
void desMakeKey(key, keyBits, keysize, decr)
   desKeyType    **key;
   u8            *keyBits;
   unsigned      keysize;
   int           decr;
{
   desUnion   keyBlock;
   bit        key64[BLOCKBITS];
   bit        key56[KEYBITS];
   stageRange stage;
   int        j;

   if (*key == (desKeyType *) 0) {
      *key = (desKeyType *) malloc(sizeof (desKeyType));
      if (*key == (desKeyType *) 0) return;
   }

   (*key)->decr = decr;
   if (keysize >= DES_BLOCKSIZE) {
      memcpy((void *) &keyBlock, (void *) keyBits, DES_BLOCKSIZE);
   } else {
      memcpy(keyBlock.bytes, keyBits, keysize);
      memset(keyBlock.bytes + keysize, 0, DES_BLOCKSIZE - keysize);
   }
   unpackKeyBlock(key64, keyBlock.bytes);
   transpose(key56, key64, KEYBITS, BLOCKBITS, keyTr1);	/* 64->56 bits */

   for (stage = 0; stage < STAGECOUNT; stage++) {
      for (j = 0; j < keyRotates[stage]; j++) {
	 rotateLeft(key56, KEYBITS/2);
	 rotateLeft(key56 + KEYBITS/2, KEYBITS/2);
      }
      key2Transpose(&((*key)->bits[!decr ? STAGECOUNT-1-stage : stage]), key56);
   }
}

/*
 * Return the size of an input block
 */
int desInBlockSize(key)
   desKeyType *key;
{
   return DES_BLOCKSIZE;
}

/*
 * Return the size of an output block
 */
int desOutBlockSize(key)
   desKeyType *key;
{
   return DES_BLOCKSIZE;
}

/* 
 * Convert a desPair to a string of bytes
 */
void desUnpackBlock(dst, src)
   u8 		*dst;
   desPair     	*src;
{
   register u8  *dp = dst + 8;
   register u32 s;

   s = src->right;
   *--dp = (u8) s; s >>= 8;
   *--dp = (u8) s; s >>= 8;
   *--dp = (u8) s; s >>= 8;
   *--dp = s;

   s = src->left;
   *--dp = (u8) s; s >>= 8;
   *--dp = (u8) s; s >>= 8;
   *--dp = (u8) s; s >>= 8;
   *--dp = s;
}

/* 
 * Convert a string of bytes to a desPair
 */
void desPackBlock(dst, src)
   desPair      *dst;
   u8      	*src;
{
   register u32  d;
   register u8   *sp = src;

   d  = *sp++; d<<= 8;
   d |= *sp++; d<<= 8;
   d |= *sp++; d<<= 8;
   d |= *sp++;
   dst->left = d;
   d  = *sp++; d<<= 8;
   d |= *sp++; d<<= 8;
   d |= *sp++; d<<= 8;
   d |= *sp++;
   dst->right = d;
}

/*
 * Optimization 13:
 *
 * Lots of instructions, but relatively fast.
 *
 * 4 each for a total of 259 instructions (64 are memory fetches)
 */
void IP(d, s)
   desPair *d, *s;
{
   register u32 l = s->left;
   register u32 r = s->right;
   register u32 i, j, k;

   i = 0; 			  j = 0;
   i	|=l&((u32)1<<10); k=l<<2; j	|=k&0x2000008;    k<<=1;
   i	|=k&0x2000008;    k<<=2;  j	|=k&((u32)1<<18); k<<=1;
   i	|=k&((u32)1<<18); k<<=2;  j	|=k&((u32)1<<11); k<<=1;
   i	|=k&((u32)1<<11); k<<=2;  j	|=k&((u32)1<<26); k<<=1;
   i	|=k&((u32)1<<26); k<<=2;  j	|=k&((u32)1<<19); k<<=1;
   i	|=k&((u32)1<<19); k<<=5;  j	|=k&((u32)1<<27); k<<=1;
   i	|=k&((u32)1<<27); k=l>>1; j	|=k&((u32)1<<10); k>>=2;
   i	|=k&((u32)1<<17); k>>=1;  j	|=k&((u32)1<<17); k>>=2;
   i	|=k&0x1000004;    k>>=1;  j	|=k&0x1000004;    k>>=2;
   i	|=k&((u32)1<<9);  k>>=1;  j	|=k&((u32)1<<9);  k>>=2;
   i	|=k&((u32)1<<16); k>>=1;  j	|=k&((u32)1<<16); k>>=2;
   i	|=k&((u32)1<<1);  k>>=1;  j	|=k&((u32)1<<1);  k>>=2;
   i	|=k&((u32)1<<8);  k>>=1;  j	|=k&((u32)1<<8);  k>>=5;
   i	|=k&1; 	 	  k>>=1;  j	|=k&1;
   				  j	|=r&((u32)1<<21); k=r<<1;
   i	|=k&((u32)1<<21); k<<=2;  j	|=k&((u32)1<<14); k<<=1;
   i	|=k&((u32)1<<14); k<<=2;  j	|=k&0x20000080;   k<<=1;
   i	|=k&0x20000080;   k<<=2;  j	|=k&((u32)1<<22); k<<=1;
   i	|=k&((u32)1<<22); k<<=2;  j	|=k&((u32)1<<15); k<<=1;
   i	|=k&((u32)1<<15); k<<=2;  j	|=k&((u32)1<<30); k<<=1;
   i	|=k&((u32)1<<30); k<<=2;  j	|=k&((u32)1<<23); k<<=1;
   i	|=k&((u32)1<<23); k<<=5;  j	|=k&((u32)1<<31); k<<=1;
   i	|=k&((u32)1<<31); k=r>>2; 
   i	|=k&0x10000040;   k>>=1;  j	|=k&0x10000040;   k>>=2;
   i	|=k&((u32)1<<13); k>>=1;  j	|=k&((u32)1<<13); k>>=2;
   i	|=k&((u32)1<<20); k>>=1;  j	|=k&((u32)1<<20); k>>=2;
   i	|=k&((u32)1<<5);  k>>=1;  j	|=k&((u32)1<<5);  k>>=2;
   i	|=k&((u32)1<<12); k>>=1;  j	|=k&((u32)1<<12); k>>=5;
   i	|=k&((u32)1<<4);  k>>=1;  j	|=k&((u32)1<<4);

   d->left  = i;		  d->right = j;
}

/*
 * Optimization 8: IP inverse = swapTr combined with finalTr 
 * Optimization 9: add l,r;
 * Optimization 13: use packed bits for l and r
 * Optimization 14: packed to packed
 *
 * 259 Instructions (64 are memory stores)
 */
void IPinverse(d, l, r)
   desPair  *d;
   register u32 l, r;
{
   register u32 i;

   i =l<<7&((u32)1<<31);  i|=r<<6&((u32)1<<30);
   i|=l<<13&((u32)1<<29); i|=r<<12&((u32)1<<28);
   i|=l<<19&((u32)1<<27); i|=r<<18&((u32)1<<26);
   i|=l<<25&((u32)1<<25); i|=r<<24&((u32)1<<24);
   i|=l>>2&((u32)1<<23);  i|=r>>3&((u32)1<<22);
   i|=l<<4&((u32)1<<21);  i|=r<<3&((u32)1<<20);
   i|=l<<10&((u32)1<<19); i|=r<<9&((u32)1<<18);
   i|=l<<16&((u32)1<<17); i|=r<<15&((u32)1<<16);
   i|=l>>11&((u32)1<<15); i|=r>>12&((u32)1<<14); 
   i|=l>>5&((u32)1<<13);  i|=r>>6&((u32)1<<12);
   i|=l<<1&((u32)1<<11);  i|=r<<0&((u32)1<<10); 
   i|=l<<7&((u32)1<<9);   i|=r<<6&((u32)1<<8);
   i|=l>>20&((u32)1<<7);  i|=r>>21&((u32)1<<6);
   i|=l>>14&((u32)1<<5);  i|=r>>15&((u32)1<<4);
   i|=l>>8&((u32)1<<3);   i|=r>>9&((u32)1<<2); 
   i|=l>>2&((u32)1<<1);   i|=r>>3&((u32)1<<0);
   d->left = i;
   i =l<<3&((u32)1<<31);  i|=r<<2&((u32)1<<30);
   i|=l<<9&((u32)1<<29);  i|=r<<8&((u32)1<<28);
   i|=l<<15&((u32)1<<27); i|=r<<14&((u32)1<<26);
   i|=l<<21&((u32)1<<25); i|=r<<20&((u32)1<<24);
   i|=l>>6&((u32)1<<23);  i|=r>>7&((u32)1<<22); 
   i|=l<<0&((u32)1<<21);  i|=r>>1&((u32)1<<20);
   i|=l<<6&((u32)1<<19);  i|=r<<5&((u32)1<<18); 
   i|=l<<12&((u32)1<<17); i|=r<<11&((u32)1<<16);
   i|=l>>15&((u32)1<<15); i|=r>>16&((u32)1<<14); 
   i|=l>>9&((u32)1<<13);  i|=r>>10&((u32)1<<12); 
   i|=l>>3&((u32)1<<11);  i|=r>>4&((u32)1<<10);
   i|=l<<3&((u32)1<<9);   i|=r<<2&((u32)1<<8);
   i|=l>>24&((u32)1<<7);  i|=r>>25&((u32)1<<6);
   i|=l>>18&((u32)1<<5);  i|=r>>19&((u32)1<<4);
   i|=l>>12&((u32)1<<3);  i|=r>>13&((u32)1<<2); 
   i|=l>>6&((u32)1<<1);   i|=r>>7&((u32)1<<0);
   d->right = i;
}

/*
 * This function accounts for at least 60% of execution time
 */
u32 desFunc(inp, key)
   u32 		inp;
   u6Block     	key;
{
   register u32	 p, r, q;

   p   = inp; p >>= 27;
   q   = p;   q  &= 3;  q <<= 4;
   r   = inp; r <<= 5;
   p  |= r;
   r  = sBoxp[0][key[0] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[7][key[7] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[6][key[6] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[5][key[5] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[4][key[4] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[3][key[3] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[2][key[2] ^ (p & 63)]; p >>= 4;
   r |= sBoxp[1][key[1] ^ (p | q)];

   return r;
}

void des(dst, src, key)
   u8          *dst;
   u8	       *src;
   desKeyType  *key;
{
   desPair	dblock, sblock;
   stageRange  	stage = STAGECOUNT;
   register u32	left, right, res;
   desPair  	temp;

   desPackBlock(&sblock, src);
   IP(&temp, &sblock);
   left  = temp.left;
   right = temp.right;

   do {
      res   = desFunc(right, key->bits[--stage]);
      res  ^= left;
      left  = right;
      right = res;
   } while (stage != 0);

   IPinverse(&dblock, left, right);
   desUnpackBlock(dst, &dblock);
}
@EOF

chmod 444 desblock.c

echo x - sboxp.c
cat >sboxp.c <<'@EOF'
#include "desdefs.h"

/*
 * Optimization 13: sBoxes  with pTr and emod built-in
 */
u32 sBoxp[8][64] = {
   {
      0x00808200, 0x00000000, 0x00008000, 0x00808202, 
      0x00808002, 0x00008202, 0x00000002, 0x00008000, 
      0x00000200, 0x00808200, 0x00808202, 0x00000200, 
      0x00800202, 0x00808002, 0x00800000, 0x00000002, 
      0x00000202, 0x00800200, 0x00800200, 0x00008200, 
      0x00008200, 0x00808000, 0x00808000, 0x00800202, 
      0x00008002, 0x00800002, 0x00800002, 0x00008002, 
      0x00000000, 0x00000202, 0x00008202, 0x00800000, 
      0x00008000, 0x00808202, 0x00000002, 0x00808000, 
      0x00808200, 0x00800000, 0x00800000, 0x00000200, 
      0x00808002, 0x00008000, 0x00008200, 0x00800002, 
      0x00000200, 0x00000002, 0x00800202, 0x00008202, 
      0x00808202, 0x00008002, 0x00808000, 0x00800202, 
      0x00800002, 0x00000202, 0x00008202, 0x00808200, 
      0x00000202, 0x00800200, 0x00800200, 0x00000000, 
      0x00008002, 0x00008200, 0x00000000, 0x00808002, 
   }, {
      0x40084010, 0x40004000, 0x00004000, 0x00084010, 
      0x00080000, 0x00000010, 0x40080010, 0x40004010, 
      0x40000010, 0x40084010, 0x40084000, 0x40000000, 
      0x40004000, 0x00080000, 0x00000010, 0x40080010, 
      0x00084000, 0x00080010, 0x40004010, 0x00000000, 
      0x40000000, 0x00004000, 0x00084010, 0x40080000, 
      0x00080010, 0x40000010, 0x00000000, 0x00084000, 
      0x00004010, 0x40084000, 0x40080000, 0x00004010, 
      0x00000000, 0x00084010, 0x40080010, 0x00080000, 
      0x40004010, 0x40080000, 0x40084000, 0x00004000, 
      0x40080000, 0x40004000, 0x00000010, 0x40084010, 
      0x00084010, 0x00000010, 0x00004000, 0x40000000, 
      0x00004010, 0x40084000, 0x00080000, 0x40000010, 
      0x00080010, 0x40004010, 0x40000010, 0x00080010, 
      0x00084000, 0x00000000, 0x40004000, 0x00004010, 
      0x40000000, 0x40080010, 0x40084010, 0x00084000, 
   }, {
      0x00000104, 0x04010100, 0x00000000, 0x04010004, 
      0x04000100, 0x00000000, 0x00010104, 0x04000100, 
      0x00010004, 0x04000004, 0x04000004, 0x00010000, 
      0x04010104, 0x00010004, 0x04010000, 0x00000104, 
      0x04000000, 0x00000004, 0x04010100, 0x00000100, 
      0x00010100, 0x04010000, 0x04010004, 0x00010104, 
      0x04000104, 0x00010100, 0x00010000, 0x04000104, 
      0x00000004, 0x04010104, 0x00000100, 0x04000000, 
      0x04010100, 0x04000000, 0x00010004, 0x00000104, 
      0x00010000, 0x04010100, 0x04000100, 0x00000000, 
      0x00000100, 0x00010004, 0x04010104, 0x04000100, 
      0x04000004, 0x00000100, 0x00000000, 0x04010004, 
      0x04000104, 0x00010000, 0x04000000, 0x04010104, 
      0x00000004, 0x00010104, 0x00010100, 0x04000004, 
      0x04010000, 0x04000104, 0x00000104, 0x04010000, 
      0x00010104, 0x00000004, 0x04010004, 0x00010100, 
   }, {
      0x80401000, 0x80001040, 0x80001040, 0x00000040, 
      0x00401040, 0x80400040, 0x80400000, 0x80001000, 
      0x00000000, 0x00401000, 0x00401000, 0x80401040, 
      0x80000040, 0x00000000, 0x00400040, 0x80400000, 
      0x80000000, 0x00001000, 0x00400000, 0x80401000, 
      0x00000040, 0x00400000, 0x80001000, 0x00001040, 
      0x80400040, 0x80000000, 0x00001040, 0x00400040, 
      0x00001000, 0x00401040, 0x80401040, 0x80000040, 
      0x00400040, 0x80400000, 0x00401000, 0x80401040, 
      0x80000040, 0x00000000, 0x00000000, 0x00401000, 
      0x00001040, 0x00400040, 0x80400040, 0x80000000, 
      0x80401000, 0x80001040, 0x80001040, 0x00000040, 
      0x80401040, 0x80000040, 0x80000000, 0x00001000, 
      0x80400000, 0x80001000, 0x00401040, 0x80400040, 
      0x80001000, 0x00001040, 0x00400000, 0x80401000, 
      0x00000040, 0x00400000, 0x00001000, 0x00401040, 
   }, {
      0x00000080, 0x01040080, 0x01040000, 0x21000080, 
      0x00040000, 0x00000080, 0x20000000, 0x01040000, 
      0x20040080, 0x00040000, 0x01000080, 0x20040080, 
      0x21000080, 0x21040000, 0x00040080, 0x20000000, 
      0x01000000, 0x20040000, 0x20040000, 0x00000000, 
      0x20000080, 0x21040080, 0x21040080, 0x01000080, 
      0x21040000, 0x20000080, 0x00000000, 0x21000000, 
      0x01040080, 0x01000000, 0x21000000, 0x00040080, 
      0x00040000, 0x21000080, 0x00000080, 0x01000000, 
      0x20000000, 0x01040000, 0x21000080, 0x20040080, 
      0x01000080, 0x20000000, 0x21040000, 0x01040080, 
      0x20040080, 0x00000080, 0x01000000, 0x21040000, 
      0x21040080, 0x00040080, 0x21000000, 0x21040080, 
      0x01040000, 0x00000000, 0x20040000, 0x21000000, 
      0x00040080, 0x01000080, 0x20000080, 0x00040000, 
      0x00000000, 0x20040000, 0x01040080, 0x20000080, 
   }, {
      0x10000008, 0x10200000, 0x00002000, 0x10202008, 
      0x10200000, 0x00000008, 0x10202008, 0x00200000, 
      0x10002000, 0x00202008, 0x00200000, 0x10000008, 
      0x00200008, 0x10002000, 0x10000000, 0x00002008, 
      0x00000000, 0x00200008, 0x10002008, 0x00002000, 
      0x00202000, 0x10002008, 0x00000008, 0x10200008, 
      0x10200008, 0x00000000, 0x00202008, 0x10202000, 
      0x00002008, 0x00202000, 0x10202000, 0x10000000, 
      0x10002000, 0x00000008, 0x10200008, 0x00202000, 
      0x10202008, 0x00200000, 0x00002008, 0x10000008, 
      0x00200000, 0x10002000, 0x10000000, 0x00002008, 
      0x10000008, 0x10202008, 0x00202000, 0x10200000, 
      0x00202008, 0x10202000, 0x00000000, 0x10200008, 
      0x00000008, 0x00002000, 0x10200000, 0x00202008, 
      0x00002000, 0x00200008, 0x10002008, 0x00000000, 
      0x10202000, 0x10000000, 0x00200008, 0x10002008, 
   }, {
      0x00100000, 0x02100001, 0x02000401, 0x00000000, 
      0x00000400, 0x02000401, 0x00100401, 0x02100400, 
      0x02100401, 0x00100000, 0x00000000, 0x02000001, 
      0x00000001, 0x02000000, 0x02100001, 0x00000401, 
      0x02000400, 0x00100401, 0x00100001, 0x02000400, 
      0x02000001, 0x02100000, 0x02100400, 0x00100001, 
      0x02100000, 0x00000400, 0x00000401, 0x02100401, 
      0x00100400, 0x00000001, 0x02000000, 0x00100400, 
      0x02000000, 0x00100400, 0x00100000, 0x02000401, 
      0x02000401, 0x02100001, 0x02100001, 0x00000001, 
      0x00100001, 0x02000000, 0x02000400, 0x00100000, 
      0x02100400, 0x00000401, 0x00100401, 0x02100400, 
      0x00000401, 0x02000001, 0x02100401, 0x02100000, 
      0x00100400, 0x00000000, 0x00000001, 0x02100401, 
      0x00000000, 0x00100401, 0x02100000, 0x00000400, 
      0x02000001, 0x02000400, 0x00000400, 0x00100001, 
   }, {
      0x08000820, 0x00000800, 0x00020000, 0x08020820, 
      0x08000000, 0x08000820, 0x00000020, 0x08000000, 
      0x00020020, 0x08020000, 0x08020820, 0x00020800, 
      0x08020800, 0x00020820, 0x00000800, 0x00000020, 
      0x08020000, 0x08000020, 0x08000800, 0x00000820, 
      0x00020800, 0x00020020, 0x08020020, 0x08020800, 
      0x00000820, 0x00000000, 0x00000000, 0x08020020, 
      0x08000020, 0x08000800, 0x00020820, 0x00020000, 
      0x00020820, 0x00020000, 0x08020800, 0x00000800, 
      0x00000020, 0x08020020, 0x00000800, 0x00020820, 
      0x08000800, 0x00000020, 0x08000020, 0x08020000, 
      0x08020020, 0x08000000, 0x00020000, 0x08000820, 
      0x00000000, 0x08020820, 0x00020020, 0x08000020, 
      0x08020000, 0x08000800, 0x08000820, 0x00000000, 
      0x08020820, 0x00020800, 0x00020800, 0x00000820, 
      0x00000820, 0x00020020, 0x08000000, 0x08020800, 
   },
};
@EOF

chmod 444 sboxp.c

echo x - getkey.c
cat >getkey.c <<'@EOF'
#include <string.h>
#include <fcntl.h>

#ifndef BSD		/* System V */
#include <sys/ioctl.h>
#include <termio.h>

#define GETMODES	TCGETA
#define	SETMODES	TCSETA
#define	TTYFLAGS	c_lflag
#define	MODETYPE	termio
#endif

#ifdef BSD
#include <sgtty.h>

#define GETMODES	TIOCGETP
#define	SETMODES	TIOCSETN
#define	TTYFLAGS	sg_flags 
#define	MODETYPE	sgttyb
#endif

#ifndef MSDOS
#include <signal.h>

int setEcho(fd, echo)
   int fd;
   int echo;
{  
   struct MODETYPE modes;
   int res, oldecho;

   res = ioctl(fd, GETMODES, &modes);
   oldecho = modes.TTYFLAGS & ECHO;
   if (echo >= 0) {
      if (echo) {
	 modes.TTYFLAGS |= ECHO;
      } else {
	 modes.TTYFLAGS &= ~ECHO;
      }
      res = ioctl(fd, SETMODES, &modes);
   }
   return oldecho;
}

static void (*oldSigInt)();
static int  oldEcho = 1;			/* assume echo was on */
static int  fd = -1;

void intHandler()
{
   setEcho(fd, oldEcho);			/* restore echoing */
   close(fd);					/* close /dev/tty */
   (void) signal(SIGINT, oldSigInt);		/* restore old handler */
   kill(getpid(), SIGINT);			/* invoke old handler */
}

/*
 * A machine dependent function to prompt for and read a keystring from stdin
 *
 * Input:
 *   prompt - A string output to display prior to requesting input
 *   str    - where to put the characters
 *   size   - the number of storage locations reserved for the key
 *    
 * Returns: 
 *    The number of characters read (not counting terminating '\n')
 *
 * Reads in upto <size> characters from the terminal.  Terminated by EOF
 * or '\n'.  String will be '\0' terminated if its less than size bytes.
 */
int getkey(prompt, str, size)
   char *prompt;
   char *str;
   register unsigned size;
{
   int count, len;
   char buf[1], *chp = str;;

   fd = open("/dev/tty", O_RDWR);
   if (fd < 0) return fd;
   oldSigInt = signal(SIGINT, intHandler);
   oldEcho = setEcho(fd, 0);		/* disable printing of input */

   len   = strlen(prompt);
   count = write(fd, prompt, len);

   if (size != 0) do {
      count = read(fd, buf, 1);
      if (count != 1) break;
      if (buf[0] == '\n') break;
      *chp++ = buf[0];
   } while (--size != 0);
 
   if (size != 0) {
      *chp = '\0';
   }
   write(fd, "\n", 1);			/* goto next line */
   setEcho(fd, oldEcho);		/* restore echo to previous state */
   (void) signal(SIGINT, oldSigInt);
   close(fd);
   return chp - str;
}
#endif
@EOF

chmod 444 getkey.c

echo x - destest.c
cat >destest.c <<'@EOF'
/*
 * Maintenance tests for the Data Encryption Standard
 *
 * From National Bureau of Standards Special Publication 500-61
 *
 * Written by David Barrett (barrett%asgard@boulder.Colorado.EDU)
 *
 * Exit status 0 for success, non-zero for failure
 */
#include <stdio.h>
#include <string.h>
#include "des.h"

extern int optind;
extern char *optarg;

int verbose = 0;
char *progName;

#define BLOCKSIZE	8
#define TESTCOUNT	4

typedef char  block[BLOCKSIZE];

block testRes[TESTCOUNT] = {
   { 0xbf, 0x1f, 0xf3, 0x7b, 0xc4, 0x6c, 0xc2, 0xca },
   { 0x1d, 0xfc, 0xf1, 0xc8, 0x44, 0xe8, 0x4a, 0x9b },
   { 0x00, 0xb8, 0x2c, 0xbb, 0xe5, 0x8d, 0xbb, 0x9f },
   { 0x24, 0x6e, 0x9d, 0xb9, 0xc5, 0x50, 0x38, 0x1a }
};

int testCounts[TESTCOUNT] = { 3, 6, 8, 64 };

char *testMessages[TESTCOUNT] = {
   "  Test 1: Output Stuck Fault Test\n",
   "  Test 2: Test 1 plus Sbox, P and E Test\n",
   "  Test 3: Test 2 plus Complete Stuck Fault Test\n",
   "  Test 4: Test 3 plus IP and IP inverse -- Tests Everything\n",
};

void showBlock(stream, src)
   FILE *stream;
   char *src;
{
   register unsigned size = BLOCKSIZE;
   do {
      fprintf(stream, "%.2x", (unsigned char) *src++);
   } while (--size != 0);
}

int main(argc, argv)
   int argc;
   char *argv[];
{
   int	    ch, exitcode = 0, count;
   char	    *chp;
   keyType  key;
   int	    res, testnum;
   block    plain, keybits;

   progName = *argv;
   if ((chp = strrchr(progName, '/')) != (char *) 0) progName = chp+1;

   while ((ch = getopt(argc, argv, "v")) != EOF) switch (ch) {
   case 'v':
      verbose++;
      break;
   case '?':
   default:
usage:
      fprintf(stderr, "usage: %s [-v ]\n", progName);
      return 1;
   }
   argc -= optind;
   argv += optind;

   if (argc != 0) goto usage;

   key = (keyType) 0;
   desMakeKey(&key, keybits, BLOCKSIZE, 0);
   if (key == (keyType) 0) {
      fprintf(stderr, "%s: couldn't allocate memory for encryption key\n",
	 progName);
      return 1;	 
   }

   for (testnum = 0; testnum < TESTCOUNT; testnum++) {
      count = testCounts[testnum];
      if (verbose) {
	 fputs(testMessages[testnum], stderr);
      }
      memset(keybits, 0x55, BLOCKSIZE);
      memset(plain,   0xff, BLOCKSIZE);
      do {
	 desMakeKey(&key, keybits, BLOCKSIZE, 0);	/* 0 means encrypt */
	 des(plain, plain, key);
	 des(keybits, plain, key);
	 desMakeKey(&key, keybits, BLOCKSIZE, 1);	/* 1 means decrypt */
	 des(keybits, plain, key);
      } while (--count != 0);
      res = memcmp(keybits, testRes[testnum], BLOCKSIZE);
      if (res != 0) {
	 fprintf(stderr, "%s: test %d failed, expected ", progName, testnum+1);
	 showBlock(stderr, testRes[testnum]);
	 fputs(" got ", stderr);
	 showBlock(stderr, keybits);
	 putc('\n', stderr);
	 exitcode |= (1 << testnum);
      }
   }

   if (verbose) {
      if (exitcode) {
	 fprintf(stderr, "%s: Test Failed\n", progName);
      } else {
	 fprintf(stderr, "%s: Test Passed\n", progName);
      }
   }

   free(key);
   return exitcode;
}
@EOF

chmod 444 destest.c

echo x - desvalid.c
cat >desvalid.c <<'@EOF'
/*
 * Data Encryption Standard Validation Tests
 *
 * From National Bureau of Standards Special Publication 500-20
 *
 * Written by David A. Barrett (barrett%asgard@boulder.Colorado.EDU)
 *
 * Exit status 0 for success, non-zero for failure
 */
#include <stdio.h>
#include <string.h>
#include "des.h"

extern int errno;
extern int optind;
extern char *optarg;

int verbose = 0;
char *progName;

#define LINELEN		80
#define BLOCKSIZE 	8

typedef char block[BLOCKSIZE];

int hexdigit(ch)
   register char ch;
{
   if (ch >= '0' && ch <= '9') return ch - '0';
   if (ch >= 'a' && ch <= 'f') return ch - 'a' + 10;
   if (ch >= 'A' && ch <= 'F') return ch - 'A' + 10;
   return -1;
}

void getItem(dst, src, size)
   register char *dst, *src;
   register unsigned size;
{
   register int ch;

   do {
      ch = hexdigit(*src++); ch = (ch << 4) | hexdigit(*src++);
      *dst++ = ch;
   } while (--size != 0);
}

/*
 * Returns:
 *    1 for decrypt, 0 for encrypt
 */
int getparms(src, key, plain, cipher)
   char *src, *key, *plain, *cipher;
{
   register int ch;
   int count = 0, decr = 0;

   while ((ch = *src) != '\n') {
      src++;
      switch (ch) {
      case 'K':
	 getItem(key, src, BLOCKSIZE);
	 src += 16;
	 count++;
	 break;
      case 'P':
	 getItem(plain, src, BLOCKSIZE);
	 src += 16;
	 count++;
	 break;
      case 'S':
	 getItem(cipher, src, BLOCKSIZE);
	 if (count == 1) {
	    decr = 1;
	 }
	 src += 16;
	 count++;
	 break;
      }
      if (count == 3) break;
   }
   return decr;
}

void showItem(stream, src, count)
   FILE *stream;
   char *src;
   int count;
{
   do {
      fprintf(stream, "%.2x", (unsigned char) *src++);
   } while (--count != 0);
}

int main(argc, argv)
   int argc;
   char *argv[];
{
   int	    ch, decr = 0, exitcode = 0;
   char	    *chp;
   int	    keylen;
   keyType  key;
   char	    line[LINELEN];
   block    cipher, plain, keystr, wbuf;
   int 	    lineno = 0;
   int	    res;

   progName = *argv;
   if ((chp = strrchr(progName, '/')) != (char *) 0) progName = chp+1;

   while ((ch = getopt(argc, argv, "v")) != EOF) switch (ch) {
   case 'v':
      verbose++;
      break;
   case '?':
   default:
usage:
      fprintf(stderr, "usage: %s [ -v ] < testdataFile\n", progName);
      return 1;
   }
   argc -= optind;
   argv += optind;

   if (argc != 0) goto usage;

   key = (keyType) 0;
   keylen = 8;
   do {
      lineno++;
      chp = fgets(line, LINELEN, stdin);
      if (chp == (char *) 0) break;

      decr = getparms(line, keystr, plain, cipher);

      if (*chp == '\n' || *chp == '#') continue;
      if (*chp == '"') {
	 if (verbose) {
	    fputs(&line[1], stdout);
	 }
	 continue;
      }

      desMakeKey(&key, keystr, keylen, decr);
      if (key == (keyType) 0) {
	 fprintf(stderr, "%s: couldn't allocate memory for encryption key\n",
	    progName);
	 return 1;	 
      }

      if (!decr) {
	 des(wbuf, plain, key);
	 res = memcmp(wbuf, cipher, 8);
      } else {
	 des(wbuf, cipher, key);
	 res = memcmp(wbuf, plain, 8);
      }
      if (res != 0) {
	 fprintf(stderr, "Failed--line %d:", lineno);
	 fputs(" k=", stderr);
	 showItem(stderr, keystr, 8);
	 fputs(" p=", stderr);
	 showItem(stderr, plain, 8);
	 fputs(" => ", stderr);
	 showItem(stderr, wbuf, 8);
	 fputs(" c=", stderr);
	 showItem(stderr, cipher, 8);
	 fputs("\n", stderr);
	 exitcode = 2;
      }
   } while (1);

   if (verbose) {
      if (exitcode) {
	 fprintf(stderr, "%s: Test Failed\n", progName);
      } else {
	 fprintf(stderr, "%s: Test Passed\n", progName);
      }
   }

   free(key);
   return exitcode;
}
@EOF

chmod 444 desvalid.c

echo x - testcfb.c
cat >testcfb.c <<'@EOF'
#include <stdio.h>
#include <string.h>
#include "des.h"

#define MAXBUFSIZE 	8192

int bufSize = 3;

char plain[MAXBUFSIZE], cipher[MAXBUFSIZE];

char ivbits[]  = { 0x12, 0x34, 0x56, 0x78, 0x90, 0xab, 0xcd, 0xef };
char keybits[] = { 0x01, 0x23, 0x45, 0x67, 0x89, 0xab, 0xcd, 0xef };

char *progName;

extern int getopt();
extern int optind;
extern char *optarg;

int main(argc, argv)
   int argc;
   char *argv[];
{
   int exitCode = 0;
   char *chp;
   int ch, rcount, ivsize, wcount, decr = 0;
   keyType key = (keyType) 0;
   char iv[DES_BLOCKSIZE];

   progName = *argv;
   if ((chp = strrchr(progName, '/')) != (char *) 0) progName = chp+1;

   while ((ch = getopt(argc, argv, "ds:")) != EOF) switch (ch) {
   case 's':
      wcount = sscanf(optarg, "%d", &bufSize);
      if (wcount != 1) goto usage;
      break;
   case 'd':
      decr++;
      break;
   case '?':
   default:
usage:
      fprintf(stderr, "usage: %s [ -d ] [ -s bufsize ]\n", progName);
      return 1;
   }
   argc -= optind;
   argv += optind;

   if (argc != 0) goto usage;

   ivsize = DES_BLOCKSIZE;
   memcpy(iv, ivbits, ivsize);
   desMakeKey(&key, keybits, DES_BLOCKSIZE, 0);
   do {
      rcount = read(0, plain, bufSize);
      if (rcount <= 0) break;
      ivsize = desCFB(cipher, plain, rcount, iv, ivsize, key, decr);
      wcount = write(1, cipher, rcount);
   } while (1);

   return exitCode;
}
@EOF

chmod 644 testcfb.c

echo x - cipher.1
cat >cipher.1 <<'@EOF'
.\" @(#) cipher.1 1.0  @(#)cipher.1	1.1  91/20/91  1   
.TH CIPHER 1 
.ds )H David A. Barrett
.ds ]W Revision 1.0: Jan 1991
.SH NAME
cipher, decipher \- Fast DES-compatible encryption
.SH SYNOPSIS
.B cipher
[
.B \-de
] [ 
.B \-i
.I ivec
] [
.B \-x
.I hexkey
] [
.B \-k
.I keystr
]
.SH DESCRIPTION
.PP
.I Cipher\^
is an encryption program compatible with the National Bureau of
Standards 
.I Data Encryption Standard,
published in 
.I FIPS Publication 46-1 
(January 22, 1988).
.PP
.ne 8
.I Cipher
reads from the standard input and writes
on the standard output.
The
.I keystr\^
is a character string which
selects a particular transformation.
The output will be unintelligible to anyone who does
not specify the same 
.I keystr\^
to the
.I decipher
program.
Output will contain the same number of characters and the input but
consists of binary characters of eight-bits each.
If no key
is given (using the,
.B \-k
or 
.B \-x
option),
.I cipher\^
demands a key from the terminal and turns
off printing while the key is typed in.
This is recomended since
users running the
.I ps(1)
can see keys specified on the command line.
To assist in preventing typographic errors during key
entry, each key must be entered twice.  This feature may
be disabled by specifying the
.B \-n 
option.

.SS Options
.PP
.TP 11
.B  \-d
Used to decipher previously ciphered text.
.TP
.B  \-e
Encipher mode.  More than one
.B \-e
or
.B \-d
option forces multiple encryption.
.TP
.B \-n
inhibits key verification
.TP
.BI \-k\ keystr
Specifies a character string to use as the key for encryption/decryption.
.TP
.BI \-x\ hexkey
Specifies the key as a hexadecimal number.  One to 16 digits may be
specified.  This key is left-justified and zero-padded.
.TP
.BI \-i\ ivec
Specifies the initialization vector for cipher-feedback mode (CFB) 
as a one to 16-digit hexadecimal number.  This will be right-justified 
and zero padded.
.PP
The
.B \-x,
.B \-i,
and
.B \-k
options are primaraly useful for test scripts.
.PP
Unlike the crypt command,
.I cipher
is not its own inverse; you must use the
.B \-d
option to decipher previously encrypted text or invoke the command as
.I decipher.
.PP
The security of the Data Encryption Standard has been controversial.
In particular, the number of possible keys has
been criticized as too small; only 56-bits are used.  To assist
in minimizing this risk, multiple-encryption, and "random" 
key-generation from text strings is provided.

The key string may be any length other than zero.
This string is hashed to produce the 56-bit key used for the DES.

To help thwart dictionary attacks, the key should be as long as 
convienient and contain a mix of upper-case, lower-case and 
symbolic characters (space and control characters are permitted).
Short sentences or phrases consisting of nonsense words are reccomended.

These precautions should make it more difficult for someone
to use
computer(s) (or DES hardware) to guess your key by trial and
error.  This is a very serious threat and should not be ignored.
.PP
For particularly sensitive information, double
or triple encryption with independent keys should be used.
Attempts to crack the encrypted text may be made more difficult by
removing redundancy from the input by using the
.I compress(1)
command prior to enciphering and subsequent to deciphering.
(Even further security can be obtained by specifying the
.B \-n
option to 
.I compress 
so that no header is included.)
.ne 8
.PP
The following command illustrates encryption of the file
.I clear
to produce the file
.I cypher.
.PP
.RS
compress -n <clear | cipher \|>cypher
.br
Input Key:
.br
Verify Key:
.br
rm clear
.br
.RE
.PP
.PP
This command is used to examine the previously enciphered file:
.PP
.RS
cipher -d <cypher | uncompress -n | more
.br
Input Key:
.br
.RE
.PP
The following command may be used to accomplish multiple-encipherment:
(The key text is shown only for illustration)
.PP
.RS
cipher -e -e <plain >cipherfile
.br
Input Key:firsty keyzy
.br
Input Key:seconDzy keysy
.br
.RE
.PP
A prompt for each cipher key is shown.  When multiple-encipherment is
selected, care should be taken to specify the keys in the reverse order
when deciphering. All the following commands below are equivalent ways
of deciphering the above:
.PP
.RS
cipher -d -d <cipherfile >plain
.br
Input Key:seconDzy keysy
.br
Input Key:firsty keyzy
.br
cipher -dk "seconDzy keysy" -dk "firsty keyzy" <cipherfile >plain
.br
cipher -d -k "seconDzy keysy" <cipherfile \\
.br
| decipher -k "firsty keyzy" >plain
.RE
.PP
For transmitting encrypted text though the mail system, the
.I atob(1),
and
.I btoa(1),
commands may be used.
These programs are available as part of the
.I compress
4.0 package. (also included with the 
.I cipher 
package)
.PP
For example, to send a secret message, typed from the terminal:
.PP
.RS
compress -n | cipher | btoa | mail user
.RE
.PP
The receiver could save the message in the file
.I secret
and read it using the command:
.PP
.RS
atob <secret | decipher | uncompress -n
.RE
.PP
Notice that you did not have to worry about stripping mailer headers 
from the text because the
.I atob
program does that automatically.
.PP
Since the Data Encryption Standard is, by definition, implemented 
only in hardware, this algorithm should not be considered as a DES
implementation. However, it should yield the same results as
DES hardware using 64-bit Cipher-Feedback Mode (CFB). (See
FIPS Publications 81 and 74).
.PP
The key used as input to the DES is generated as follows:
The keystring is padded with blank characters to a positive multiple of 
eight.
A secondary key is generated from the first eight characters of
.I keystr
by shifting each character left by one (discarding each high-order bit). 
This secondary key is used to produce a 64-bit authentication code by
enciphering the rest of
.I keystr
using DES in cipher-block-chaining (CBC) encryption mode with
an initialization vector of zeros.
This 64-bit authentication code is used as the encryption key.
This is the same method used by FIPS publication 112 except the 
authentication code is not converted into printable form.
This is also identical to FIPS publication 113 with the input padded with
blanks instead of zeros.

The initialization vector is generated from a string of all zeros.
.PP
.SH WARNINGS
If output is piped to
.IR nroff (1)
and the encryption key is
.I not\^
given on the command line,
.I cipher\^
can leave terminal modes with echoing disabled.
(see
.IR stty (1)).
.PP
If two or more files encrypted with the same key are concatenated
and an attempt is made to decrypt the result, only the
contents of the first of the original files will be decrypted correctly.
.SH ACKNOWLEDGEMENTS
The author has made every attempt to produce the fastest, portable
DES-compatible program possible, but considerable speed improvements 
remain.  Comments and improvements
will be greatly appreciated and should be directed to the author:
.PP
David A. Barrett (barrett%asgard@boulder.Colorado.EDU)
.PP
This program is not to be distributed for profit.
.SH FILES
.ta 1i
/dev/tty	for typed key
.DT
.SH SEE ALSO
crypt(1),
compress(1),
btoa(1),
atob(1),
makekey(1), 
des(3),
desCFB(3),
crypt(3),
stty(1).
.\" index	\fIcrypt\fR \- encode/decode files 	 \s-2CRYPT\s+1(1)\s+1
.\" index	decode/encode files 	 \s-2CIPHER\s+1(1)\s+1
.\" index	encode/decode files 	 \s-2CIPHER\s+1(1)\s+1
.\" index	decrypt/encrypt files 	 \s-2CIPHER\s+1(1)\s+1
.\" index	encrypt/decrypt files 	 \s-2CIPHER\s+1(1)\s+1
.\" index	files: encrypt/decrypt files 	 \s-2CIPHER\s+1(1)\s+1
.\"
.\" toc	\s-2CIPHER\s+1(1)\s+1:\0\0\fIcipher\fR 	 encode/decode files
@EOF

chmod 444 cipher.1

echo x - cmail
cat >cmail <<'@EOF'

# cmail - a virtual mailer for sending secret mail
#
# To send secret mail, envoke as you normally envoke mail.
#
# To receive mail, run your normal mailer and when you receive secret
# mail, send the message to cmail as follows:
#
#   s | cmail
#
# Note: the s| feature does not exist in the Berkely mailer.
#
# In both cases, you will be prompted for an encryption key.
# 
# NOTE: mail cleartext will appear in a temporory file which is
#       readable only by you or the super user during the time that you 
#       are editing the message. 
#
encr=cipher
decr=decipher
btoa=btoa	
atob=atob
mail=mailx				# Change for your mailer.
edit=vi					# Change for your editor.
tmp=$HOME/.Sm$$				# temp file
#
umask 077				# Secure for temp files.
if [ $# -eq 0 ]				# If envoked with no arguments,
then					# just invert the process.
   $atob | $decr | uncompress -n
else					# If sending mail...
   trap "mv $tmp $home/smail.$$" 1 2 3 	# If killed.
   rm -f $tmp				# Kill the temp file if it exists.
   if tty -s				# if interactive, fork an editor.
   then					# Here is where the cleartext is!
      $edit $tmp
   else					# Otherwise just cat the input into
      cat >$tmp				# the tempfile.
   fi
   if [ -s $tmp ] 			# If file is not empty, send it.
   then 				# Much handwaving for quoted stuff.
      echo cat $tmp \| compress -n \| $encr \| $btoa \| $mail `(for i do
	 echo \'$i\'
      done)` \; rm $tmp | exec sh 	# note the EXEC!
   fi					# NOT EXECUTED!
fi
@EOF

chmod 755 cmail

echo x - testdata.des
cat >testdata.des <<'@EOF'
#
# Test Data for the Data Encryption Standard (see testdes.c)
#
# From National Bureau of Standards Special Publication 500-20, Sep-80.
#
# Column 1: Key
# Column 2: PlainText 
# Column 3: CipherText
#
# If column 2 begins with a P, then encrypt plaintext to produce ciphertext
# If column 2 begins with a S, then decrypt ciphertext to produce plaintext
#
# Lines beginning with # are comments
# Lines beginning with " are output by the test program when in verbose mode
#
"  Test 1:  Initial Permutation IP
K0101010101010101	P95f8a5e5dd31d900	S8000000000000000
K0101010101010101	Pdd7f121ca5015619	S4000000000000000
K0101010101010101	P2e8653104f3834ea	S2000000000000000
K0101010101010101	P4bd388ff6cd81d4f	S1000000000000000
K0101010101010101	P20b9e767b2fb1456	S0800000000000000
K0101010101010101	P55579380d77138ef	S0400000000000000
K0101010101010101	P6cc5defaaf04512f	S0200000000000000
K0101010101010101	P0d9f279ba5d87260	S0100000000000000
K0101010101010101	Pd9031b0271bd5a0a	S0080000000000000
K0101010101010101	P424250b37c3dd951	S0040000000000000
K0101010101010101	Pb8061b7ecd9a21e5	S0020000000000000
K0101010101010101	Pf15d0f286b65bd28	S0010000000000000
K0101010101010101	Padd0cc8d6e5deba1	S0008000000000000
K0101010101010101	Pe6d5f82752ad63d1	S0004000000000000
K0101010101010101	Pecbfe3bd3f591a5e	S0002000000000000
K0101010101010101	Pf356834379d165cd	S0001000000000000
K0101010101010101	P2b9f982f20037fa9	S0000800000000000
K0101010101010101	P889de068a16f0be6	S0000400000000000
K0101010101010101	Pe19e275d846a1298	S0000200000000000
K0101010101010101	P329a8ed523d71aec	S0000100000000000
K0101010101010101	Pe7fce22557d23c97	S0000080000000000
K0101010101010101	P12a9f5817ff2d65d	S0000040000000000
K0101010101010101	Pa484c3ad38dc9c19	S0000020000000000
K0101010101010101	Pfbe00a8a1ef8ad72	S0000010000000000
K0101010101010101	P750d079407521363	S0000008000000000
K0101010101010101	P64feed9c724c2faf	S0000004000000000
K0101010101010101	Pf02b263b328e2b60	S0000002000000000
K0101010101010101	P9d64555a9a10b852	S0000001000000000
K0101010101010101	Pd106ff0bed5255d7	S0000000800000000
K0101010101010101	Pe1652c6b138c64a5	S0000000400000000
K0101010101010101	Pe428581186ec8f46	S0000000200000000
K0101010101010101	Paeb5f5ede22d1a36	S0000000100000000
K0101010101010101	Pe943d7568aec0c5c	S0000000080000000
K0101010101010101	Pdf98c8276f54b04b	S0000000040000000
K0101010101010101	Pb160e4680f6c696f	S0000000020000000
K0101010101010101	Pfa0752b07d9c4ab8	S0000000010000000
K0101010101010101	Pca3a2b036dbc8502	S0000000008000000
K0101010101010101	P5e0905517bb59bcf	S0000000004000000
K0101010101010101	P814eeb3b91d90726	S0000000002000000
K0101010101010101	P4d49db1532919c9f	S0000000001000000
K0101010101010101	P25eb5fc3f8cf0621	S0000000000800000
K0101010101010101	Pab6a20c0620d1c6f	S0000000000400000
K0101010101010101	P79e90dbc98f92cca	S0000000000200000
K0101010101010101	P866ecedd8072bb0e	S0000000000100000
K0101010101010101	P8b54536f2f3e64a8	S0000000000080000
K0101010101010101	Pea51d3975595b86b	S0000000000040000
K0101010101010101	Pcaffc6ac4542de31	S0000000000020000
K0101010101010101	P8dd45a2ddf90796c	S0000000000010000
K0101010101010101	P1029d55e880ec2d0	S0000000000008000
K0101010101010101	P5d86cb23639dbea9	S0000000000004000
K0101010101010101	P1d1ca853ae7c0c5f	S0000000000002000
K0101010101010101	Pce332329248f3228	S0000000000001000
K0101010101010101	P8405d1abe24fb942	S0000000000000800
K0101010101010101	Pe643d78090ca4207	S0000000000000400
K0101010101010101	P48221b9937748a23	S0000000000000200
K0101010101010101	Pdd7c0bbd61fafd54	S0000000000000100
K0101010101010101	P2fbc291a570db5c4	S0000000000000080
K0101010101010101	Pe07c30d7e4e26e12	S0000000000000040
K0101010101010101	P0953e2258e8e90a1	S0000000000000020
K0101010101010101	P5b711bc4ceebf2ee	S0000000000000010
K0101010101010101	Pcc083f1e6d9e85f6	S0000000000000008
K0101010101010101	Pd2fd8867d50d2dfe	S0000000000000004
K0101010101010101	P06e7ea22ce92708f	S0000000000000002
K0101010101010101	P166b40b44aba4bd6	S0000000000000001
"  Test 2:  IP inverse
K0101010101010101	P8000000000000000	S95f8a5e5dd31d900
K0101010101010101	P4000000000000000	Sdd7f121ca5015619
K0101010101010101	P2000000000000000	S2e8653104f3834ea
K0101010101010101	P1000000000000000	S4bd388ff6cd81d4f
K0101010101010101	P0800000000000000	S20b9e767b2fb1456
K0101010101010101	P0400000000000000	S55579380d77138ef
K0101010101010101	P0200000000000000	S6cc5defaaf04512f
K0101010101010101	P0100000000000000	S0d9f279ba5d87260
K0101010101010101	P0080000000000000	Sd9031b0271bd5a0a
K0101010101010101	P0040000000000000	S424250b37c3dd951
K0101010101010101	P0020000000000000	Sb8061b7ecd9a21e5
K0101010101010101	P0010000000000000	Sf15d0f286b65bd28
K0101010101010101	P0008000000000000	Sadd0cc8d6e5deba1
K0101010101010101	P0004000000000000	Se6d5f82752ad63d1
K0101010101010101	P0002000000000000	Secbfe3bd3f591a5e
K0101010101010101	P0001000000000000	Sf356834379d165cd
K0101010101010101	P0000800000000000	S2b9f982f20037fa9
K0101010101010101	P0000400000000000	S889de068a16f0be6
K0101010101010101	P0000200000000000	Se19e275d846a1298
K0101010101010101	P0000100000000000	S329a8ed523d71aec
K0101010101010101	P0000080000000000	Se7fce22557d23c97
K0101010101010101	P0000040000000000	S12a9f5817ff2d65d
K0101010101010101	P0000020000000000	Sa484c3ad38dc9c19
K0101010101010101	P0000010000000000	Sfbe00a8a1ef8ad72
K0101010101010101	P0000008000000000	S750d079407521363
K0101010101010101	P0000004000000000	S64feed9c724c2faf
K0101010101010101	P0000002000000000	Sf02b263b328e2b60
K0101010101010101	P0000001000000000	S9d64555a9a10b852
K0101010101010101	P0000000800000000	Sd106ff0bed5255d7
K0101010101010101	P0000000400000000	Se1652c6b138c64a5
K0101010101010101	P0000000200000000	Se428581186ec8f46
K0101010101010101	P0000000100000000	Saeb5f5ede22d1a36
K0101010101010101	P0000000080000000	Se943d7568aec0c5c
K0101010101010101	P0000000040000000	Sdf98c8276f54b04b
K0101010101010101	P0000000020000000	Sb160e4680f6c696f
K0101010101010101	P0000000010000000	Sfa0752b07d9c4ab8
K0101010101010101	P0000000008000000	Sca3a2b036dbc8502
K0101010101010101	P0000000004000000	S5e0905517bb59bcf
K0101010101010101	P0000000002000000	S814eeb3b91d90726
K0101010101010101	P0000000001000000	S4d49db1532919c9f
K0101010101010101	P0000000000800000	S25eb5fc3f8cf0621
K0101010101010101	P0000000000400000	Sab6a20c0620d1c6f
K0101010101010101	P0000000000200000	S79e90dbc98f92cca
K0101010101010101	P0000000000100000	S866ecedd8072bb0e
K0101010101010101	P0000000000080000	S8b54536f2f3e64a8
K0101010101010101	P0000000000040000	Sea51d3975595b86b
K0101010101010101	P0000000000020000	Scaffc6ac4542de31
K0101010101010101	P0000000000010000	S8dd45a2ddf90796c
K0101010101010101	P0000000000008000	S1029d55e880ec2d0
K0101010101010101	P0000000000004000	S5d86cb23639dbea9
K0101010101010101	P0000000000002000	S1d1ca853ae7c0c5f
K0101010101010101	P0000000000001000	Sce332329248f3228
K0101010101010101	P0000000000000800	S8405d1abe24fb942
K0101010101010101	P0000000000000400	Se643d78090ca4207
K0101010101010101	P0000000000000200	S48221b9937748a23
K0101010101010101	P0000000000000100	Sdd7c0bbd61fafd54
K0101010101010101	P0000000000000080	S2fbc291a570db5c4
K0101010101010101	P0000000000000040	Se07c30d7e4e26e12
K0101010101010101	P0000000000000020	S0953e2258e8e90a1
K0101010101010101	P0000000000000010	S5b711bc4ceebf2ee
K0101010101010101	P0000000000000008	Scc083f1e6d9e85f6
K0101010101010101	P0000000000000004	Sd2fd8867d50d2dfe
K0101010101010101	P0000000000000002	S06e7ea22ce92708f
K0101010101010101	P0000000000000001	S166b40b44aba4bd6
"  Test 3:  Permutation Matrix P
K1046913489980131	P0000000000000000	S88d55e54f54c97b4
K1007103489988020	P0000000000000000	S0c0cc00c83ea48fd
K10071034c8980120	P0000000000000000	S83bc8ef3a6570183
K1046103489988020	P0000000000000000	Sdf725dcad94ea2e9
K1086911519190101	P0000000000000000	Se652b53b550be8b0
K1086911519580101	P0000000000000000	Saf527120c485cbb0
K5107b01519580101	P0000000000000000	S0f04ce393db926d5
K1007b01519190101	P0000000000000000	Sc9f00ffc74079067
K3107915498080101	P0000000000000000	S7cfd82a593252b4e
K3107919498080101	P0000000000000000	Scb49a2f9e91363e3
K10079115b9080140	P0000000000000000	S00b588be70d23f56
K3107911598080140	P0000000000000000	S406a9a6ab43399ae
K1007d01589980101	P0000000000000000	S6cb773611dca9ada
K9107911589980101	P0000000000000000	S67fd21c17dbb5d70
K9107d01589190101	P0000000000000000	S9592cb4110430787
K1007d01598980120	P0000000000000000	Sa6b7ff68a318ddd3
K1007940498190101	P0000000000000000	S4d102196c914ca16
K0107910491190401	P0000000000000000	S2dfa9f4573594965
K0107910491190101	P0000000000000000	Sb46604816c0e0774
K0107940491190401	P0000000000000000	S6e7e6221a4f34e87
K19079210981a0101	P0000000000000000	Saa85e74643233199
K1007911998190801	P0000000000000000	S2e5a19db4d1962d6
K10079119981a0801	P0000000000000000	S23a866a809d30894
K1007921098190101	P0000000000000000	Sd812d961f017d320
K100791159819010b	P0000000000000000	S055605816e58608f
K1004801598190101	P0000000000000000	Sabd88e8b1b7716f1
K1004801598190102	P0000000000000000	S537ac95be69da1e1
K1004801598190108	P0000000000000000	Saed0f6ae3c25cdd8
K1002911598100104	P0000000000000000	Sb3e35a5ee53e7b8d
K1002911598190104	P0000000000000000	S61c79c71921a2ef8
K1002911598100201	P0000000000000000	Se2f5728f0995013c
K1002911698100101	P0000000000000000	S1aeac39a61f0a464
"  Test 4a: Key Permuted Choices 1 and 2 (PC1 & PC2) [encryption]
K8001010101010101	P0000000000000000	S95a8d72813daa94d
K4001010101010101	P0000000000000000	S0eec1487dd8c26d5
K2001010101010101	P0000000000000000	S7ad16ffb79c45926
K1001010101010101	P0000000000000000	Sd3746294ca6a6cf3
K0801010101010101	P0000000000000000	S809f5f873c1fd761
K0401010101010101	P0000000000000000	Sc02faffec989d1fc
K0201010101010101	P0000000000000000	S4615aa1d33e72f10
K0180010101010101	P0000000000000000	S2055123350c00858
K0140010101010101	P0000000000000000	Sdf3b99d6577397c8
K0120010101010101	P0000000000000000	S31fe17369b5288c9
K0110010101010101	P0000000000000000	Sdfdd3cc64dae1642
K0108010101010101	P0000000000000000	S178c83ce2b399d94
K0104010101010101	P0000000000000000	S50f636324a9b7f80
K0102010101010101	P0000000000000000	Sa8468ee3bc18f06d
K0101800101010101	P0000000000000000	Sa2dc9e92fd3cde92
K0101400101010101	P0000000000000000	Scac09f797d031287
K0101200101010101	P0000000000000000	S90ba680b22aeb525
K0101100101010101	P0000000000000000	Sce7a24f350e280b6
K0101080101010101	P0000000000000000	S882bff0aa01a0b87
K0101040101010101	P0000000000000000	S25610288924511c2
K0101020101010101	P0000000000000000	Sc71516c29c75d170
K0101018001010101	P0000000000000000	S5199c29a52c9f059
K0101014001010101	P0000000000000000	Sc22f0a294a71f29f
K0101012001010101	P0000000000000000	See371483714c02ea
K0101011001010101	P0000000000000000	Sa81fbd448f9e522f
K0101010801010101	P0000000000000000	S4f644c92e192dfed
K0101010401010101	P0000000000000000	S1afa9a66a6df92ae
K0101010201010101	P0000000000000000	Sb3c1cc715cb879d8
K0101010180010101	P0000000000000000	S19d032e64ab0bd8b
K0101010140010101	P0000000000000000	S3cfaa7a7dc8720dc
K0101010120010101	P0000000000000000	Sb7265f7f447ac6f3
K0101010110010101	P0000000000000000	S9db73b3c0d163f54
K0101010108010101	P0000000000000000	S8181b65babf4a975
K0101010104010101	P0000000000000000	S93c9b64042eaa240
K0101010102010101	P0000000000000000	S5570530829705592
K0101010101800101	P0000000000000000	S8638809e878787a0
K0101010101400101	P0000000000000000	S41b9a79af79ac208
K0101010101200101	P0000000000000000	S7a9be42f2009a892
K0101010101100101	P0000000000000000	S29038d56ba6d2745
K0101010101080101	P0000000000000000	S5495c6abf1e5df51
K0101010101040101	P0000000000000000	Sae13dbd561488933
K0101010101020101	P0000000000000000	S024d1ffa8904e389
K0101010101018001	P0000000000000000	Sd1399712f99bf02e
K0101010101014001	P0000000000000000	S14c1d7c1cffec79e
K0101010101012001	P0000000000000000	S1de5279dae3bed6f
K0101010101011001	P0000000000000000	Se941a33f85501303
K0101010101010801	P0000000000000000	Sda99dbbc9a03f379
K0101010101010401	P0000000000000000	Sb7fc92f91d8e92e9
K0101010101010201	P0000000000000000	Sae8e5caa3ca04e85
K0101010101010180	P0000000000000000	S9cc62df43b6eed74
K0101010101010140	P0000000000000000	Sd863dbb5c59a91a0
K0101010101010120	P0000000000000000	Sa1ab2190545b91d7
K0101010101010110	P0000000000000000	S0875041e64c570f7
K0101010101010108	P0000000000000000	S5a594528bebef1cc
K0101010101010104	P0000000000000000	Sfcdb3291de21f0c0
K0101010101010102	P0000000000000000	S869efd7f9f265a09
"  Test 4b: Key Permuted Choices 1 and 2 (PC1 & PC2) [decryption]
K8001010101010101	S95a8d72813daa94d	P0000000000000000
K4001010101010101	S0eec1487dd8c26d5	P0000000000000000
K2001010101010101	S7ad16ffb79c45926	P0000000000000000
K1001010101010101	Sd3746294ca6a6cf3	P0000000000000000
K0801010101010101	S809f5f873c1fd761	P0000000000000000
K0401010101010101	Sc02faffec989d1fc	P0000000000000000
K0201010101010101	S4615aa1d33e72f10	P0000000000000000
K0181010101010101	S2055123350c00858	P0000000000000000
K0141010101010101	Sdf3b99d6577397c8	P0000000000000000
K0121010101010101	S31fe17369b5288c9	P0000000000000000
K0111010101010101	Sdfdd3cc64dae1642	P0000000000000000
K0108010101010101	S178c83ce2b399d94	P0000000000000000
K0104010101010101	S50f636324a9b7f80	P0000000000000000
K0102010101010101	Sa8468ee3bc18f06d	P0000000000000000
K0101800101010101	Sa2dc9e92fd3cde92	P0000000000000000
K0101400101010101	Scac09f797d031287	P0000000000000000
K0101200101010101	S90ba680b22aeb525	P0000000000000000
K0101100101010101	Sce7a24f350e280b6	P0000000000000000
K0101080101010101	S882bff0aa01a0b87	P0000000000000000
K0101040101010101	S25610288924511c2	P0000000000000000
K0101020101010101	Sc71516c29c75d170	P0000000000000000
K0101018001010101	S5199c29a52c9f059	P0000000000000000
K0101014001010101	Sc22f0a294a71f29f	P0000000000000000
K0101012001010101	See371483714c02ea	P0000000000000000
K0101011001010101	Sa81fbd448f9e522f	P0000000000000000
K0101010801010101	S4f644c92e192dfed	P0000000000000000
K0101010401010101	S1afa9a66a6df92ae	P0000000000000000
K0101010201010101	Sb3c1cc715cb879d8	P0000000000000000
K0101010180010101	S19d032e64ab0bd8b	P0000000000000000
K0101010140010101	S3cfaa7a7dc8720dc	P0000000000000000
K0101010120010101	Sb7265f7f447ac6f3	P0000000000000000
K0101010110010101	S9db73b3c0d163f54	P0000000000000000
K0101010108010101	S8181b65babf4a975	P0000000000000000
K0101010104010101	S93c9b64042eaa240	P0000000000000000
K0101010102010101	S5570530829705592	P0000000000000000
K0101010101800101	S8638809e878787a0	P0000000000000000
K0101010101400101	S41b9a79af79ac208	P0000000000000000
K0101010101200101	S7a9be42f2009a892	P0000000000000000
K0101010101100101	S29038d56ba6d2745	P0000000000000000
K0101010101080101	S5495c6abf1e5df51	P0000000000000000
K0101010101040101	Sae13dbd561488933	P0000000000000000
K0101010101020101	S024d1ffa8904e389	P0000000000000000
K0101010101018001	Sd1399712f99bf02e	P0000000000000000
K0101010101014001	S14c1d7c1cffec79e	P0000000000000000
K0101010101012001	S1de5279dae3bed6f	P0000000000000000
K0101010101011001	Se941a33f85501303	P0000000000000000
K0101010101010801	Sda99dbbc9a03f379	P0000000000000000
K0101010101010401	Sb7fc92f91d8e92e9	P0000000000000000
K0101010101010201	Sae8e5caa3ca04e85	P0000000000000000
K0101010101010180	S9cc62df43b6eed74	P0000000000000000
K0101010101010140	Sd863dbb5c59a91a0	P0000000000000000
K0101010101010120	Sa1ab2190545b91d7	P0000000000000000
K0101010101010110	S0875041e64c570f7	P0000000000000000
K0101010101010108	S5a594528bebef1cc	P0000000000000000
K0101010101010104	Sfcdb3291de21f0c0	P0000000000000000
K0101010101010102	S869efd7f9f265a09	P0000000000000000
"  Test 5:  Exercise every S-box entry
K7ca110454a1a6e57	P01a1d6d039776742	S690f5b0d9a26939b
K0131d9619dc1376e	P5cd54ca83def57da	S7a389d10354bd271
K07a1133e4a0b2686	P0248d43806f67172	S868ebb51cab4599a
K3849674c2602319e	P51454b582ddf440a	S7178876e01f19b2a
K04b915ba43feb5b6	P42fd443059577fa2	Saf37fb421f8c4095
K0113b970fd34f2ce	P059b5e0851cf143a	S86a560f10ec6d85b
K0170f175468fb5e6	P0756d8e0774761d2	S0cd3da020021dc09
K43297fad38e373fe	P762514b829bf486a	Sea676b2cb7db2b7a
K07a7137045da2a16	P3bdd119049372802	Sdfd64a815caf1a0f
K04689104c2fd3b2f	P26955f6835af609a	S5c513c9c4886c088
K37d06bb516cb7546	P164d5e404f275232	S0a2aeeae3ff4ab77
K1f08260d1ac2465e	P6b056e18759f5cca	Sef1bf03e5dfa575a
K584023641aba6176	P004bd6ef09176062	S88bf0db6d70dee56
K025816164629b007	P480d39006ee762f2	Sa1f9915541020b56
K49793ebc79b3258f	P437540c8698f3cfa	S6fbf1cafcffd0556
K4fb05e1515ab73a7	P072d43a077075292	S2f22e49bab7ca1ac
K49e95d6d4ca229bf	P02fe55778117f12a	S5a6b612cc26cce4a
K018310dc409b26d6	P1d9d5c5018f728c2	S5f4c038ed12b2e41
K1c587f1c13924fef	P305532286d6f295a	S63fac0d034d9f793
@EOF

chmod 444 testdata.des

echo x - testin.cfb
cat >testin.cfb <<'@EOF'
Now is the time for all .
@EOF

chmod 444 testin.cfb

echo 'Compiling unpacker for non-ascii files'
pwd=`pwd`; cd /tmp
cat >unpack$$.c <<'EOF'
#include <stdio.h>
#define htoi(c) (c<='9' ? c-'0' : c-'A'+10)
main() {
	register int c, c2;
	while ((c=getchar())!=EOF) {
		if (c=='\n') continue;
		c2 = getchar();
		putchar((htoi(c)<<4) + htoi(c2));
	}
}
EOF
cc -o unpack$$ unpack$$.c
rm unpack$$.c
cd $pwd

echo x - testout.cfb '[non-ascii]'
/tmp/unpack$$ >testout.cfb <<'@EOF'
F3096249C7F46E51A69E839B1A92F78403467133898EA622DA49
@EOF

chmod 644 testout.cfb

echo x - testin
cat >testin <<'@EOF'
abcdefghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.
bcdefghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.a
cdefghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.ab
defghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abc
efghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcd
fghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcde
ghijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdef
hijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefg
ijklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefgh
jklmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghi
klmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghij
lmnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijk
mnopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijkl
nopqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklm
opqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmn
pqrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmno
qrstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnop
rstuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopq
stuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqr
tuvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrs
uvwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrst
vwxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstu
wxyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuv
xyz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvw
yz012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwx
z012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxy
012345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxyz
12345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxyz0
2345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxyz01
345ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxyz012
45ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxyz0123
5ABCDEFGHIJKLMNOPQRSTUVWXYZ6789.abcdefghijklmnopqrstuvwxyz01234
234567
@EOF

chmod 444 testin

echo x - testout '[non-ascii]'
/tmp/unpack$$ >testout <<'@EOF'
328DA251733BC0BD2163A4E675FB3B1F39CE5BE5978098AE298BE2D8BDC7377E0E646682D87591
7E5EAFDF45D8603002C7A3867FE565947696D1B3788CAE8160CC973E478021683BB59624C2647E
60B651F3E503BD16199BC35C37BA5D977F1034F1907EB88B0D3CB53767D34046A836144AC668C9
A9EA9F62B64FF2ABFF943232F4BEF141E692F55373680CACD9FE8F9C7F0E8A50D3DF7EA4760999
7B40E0E63721DE60D1CD993035537C0586C84FB3F783260BF0EA3EEB7DB102570B2EBCB66C9BE5
19FA3C2700D9AB165DF2B4E95289159D655F3FB9CFD519828DD54E4B5BAF1B9A1C51BD12C19FB7
F94F7869DD404ED2717FE982364F1673C5183909D1E3C4C3847EA89851ED23D55DB2C5CFA50A0F
0609ADE9FE3769C05C18FB70A83664B91EE4C0FBC63D3BBF8788E3FCA801FBB718341829C13CA7
2AA7FA78D6280D19D6057205497ED2C2767CC946520083233E24BF0B1B7236C061637312B4ED1D
9D7C3FA5B2C940442CFE616A08567DA24661C1EC4CF990840D56E5FC4D314998689CDCBBBCE0E9
60A32E56CAC99F04D0894545787A3934BCA9D10EBD5953898B9852A6FC2AD0A5F33583A206DD63
83CD7C6ECA4059D36F77871FE0C4DA17664CDB2F20532C77460EF281A846C4E347305E925F6F04
CEEFFFEDD1E36CFEA77152C1E0B75E53B97AB5837BF55B8C2AC34E65FB7C4B00B0642A51369491
CD7B2CEF22EC57D808280F2C7FF1875C8390ED1E14C92B13273B34587111F149ABDD0621AD8BF0
4D3DBA16B6323ACC693A5C70EC28FA8A001FCD26A92C8048BA5A45F2BADC1BD13236056602DA2A
2FA4C663FD4AD816BB6E96FF69D5904A8AA81970383E33E53D0F4BEF5E21EB824CFEFBB276E12F
4157FC8AA9B9DCCC4EFE1599C6D603CA9419F905506EDAD9EB9F0D06D41B69FE2345EFAC897D44
96918DFA9975B68E16F158D7D150D6B1F216888A5B398C9EF48E31A3D01E4CC8385A23BC00EFE1
6FA051FC14DA52AFC5B8C42C0E045D01F16A93BA70489F0CCCF162445D4E6BF56E7F3C14881F33
08E95A40C582D3CD9BAED82DFCCB5C3EF1F80F68FDEA02263DA5FF04B061192E1C5C653D673E23
5527C86C3718D61F2BF0D0E1746735C2541FD1314FC0637FDB8D7C3BFAC00983F628196EC12114
336E8F866D31420B6B31C769B762E488EF55A9E5B33EE222D6C130BB8784E3623BA35D164F2B35
65CC12D0681E8F194E3DB48052C1635DE989006EB921ECB1429BE986B859F0BFC5944B9401CCBE
4870589DAA54AF2D8BFBD82FC6817D6BDCE09B0D1D9570FA7F0EC396260A9F57B21CF274DF31DC
C4D9E4151FFC4087B13BBA246190CAAE04608F55E473AD297C05040DB82A856DB38C93DBD00D9E
5F512E0701EB59BFF881044DA22310E85BE9F07DF7C75021703F41E4AF3202AF134200B334DB91
3C76A1737289C04F2655F823068BFFDDC013564369375EC87E3A47D6632F67B1EC10090470095A
4FCC204A0C0FC090BB20A71CBED1CBC1FADA2093F5BE2A719172F0D8D13A1AB1601DA8ACEC961F
0353086FA2AE0DB42F38F19517D60F48A0B46D644003AA9C4BEBDEEDE95D35C28EFE2FEF094581
A1CB1F428411B6B285A0D28E474C310EB47BA37294957EAF33877C3D5CB6AE85D473D386F95768
26218F81D1AA6BACE90DC69FB3933578DCF5A6926734F67DFCC4C14A4FB51E5C87303A47655DF9
56C4766B18C3114578C4FA21A12752CCCA37B656C64B10898F5DDA81AEF2C163229D8F963F0289
4EBE969EBA0BF818E39BAEF2BA4DD6103E4A6B5D6EE2232C160EFEE74DEC77457E8C78D3F1119A
A2C3E360F87A2F61AC3B48258F423EC1FEE2882CBCDC85BA32C4B5B7C7C8BFB732C44EA1349C74
884295551C0E8229A118C5B96E037FA89FEDD8BD1F3DE3BE268A6DA608B65B556E2C817E32C153
F8DFC60464FBBC1C5476F7F73DF714BDB20A81C166140C6691A2825607C0EA3DA660BA98A24A64
BB754BF03EAC75BB441E626E3815CF354B8462113F0230644502007CF8884023254D2053998F32
F487A3D31932C5620ECF694F659DAF051C9FA35494228CED76A3E6D17ABCC1BB796CDFA39250CF
DAD404E5984C7742CCD19B63FCB86148355199997FF7C1B61488773A577EF756093C570268574B
F98D6877E5E022E4BA8628A4ED2E7CE4365FCCD69D9B2A88EB3367492761FC0F5668BF616A7607
0E7AE405DC16A9ABD0CE9A6E756723A3C82A1EB479D62D1F3CDC6672EF2743ADA38344F0666871
2C6DEF0D2C50A9386438AE1C204B5300A82E4579CFBE6C3F329A7BE70F9E3085415C943075095D
D3654898CA0F67111DBBC300E72DA9545E8B095C9BAC92421A8F7814AC781FF60E08909F5F562D
0DADA15291CC43B974E3DCF43270AF95975208EA4C98AF538B0DA9AEB243B41BCA02D5C4958729
B3915836D0915CC254FD8A5AA3D2FE728DA644CBF9988659C2564E09426AA18D67CA0DCE904006
BE8980886C773158E8BC2ADD68B2C8BCF028F1B2A5B20FA434D1C635FF2C485DB5C80CA36C343C
A4EE2646D1C649FEB7D77C5E0B64197935CCB148DC68B90D3AF5BDDAFE385197505D4F431A860A
463E61C6D1C31B33E621D33FEFA0AE50C50E6C4C9AF13134A945AC77B60760FFC3D5AA563DE9F6
BC6B67DE10A961CBB2801DF0FBF44DCC625799391BAFF8D4242532EB0C140206913A4701F837FE
996D90E20431ED747C17C4FA21277F893D7A790CE1A70AEA9760DCE442BFC62D20C3A5980216AB
46D1B2061710920165D3FCBB580FDD92D0F879692EDA57FD844D8EA8AF2B619276C675763CF168
F9078C4D3355195DE3E109EFFA9EAD336984C6B9CE9F3685F43C1C1FBE7039A3407FCD233C849F
A3C200A885BC08319525A892CE953E1FF44085D188B61386ECD0A1
@EOF

chmod 644 testout

echo x - atob.c
cat >atob.c <<'@EOF'
/* atob: version 4.0
 * stream filter to change printable ascii from "btoa" back into 8 bit bytes
 * if bad chars, or Csums do not match: exit(1) [and NO output]
 *
 *  Paul Rutter         Joe Orost
 *  philabs!per         petsd!joe
 */

#include <stdio.h>
#include <ctype.h>

#define reg register

#define streq(s0, s1)  strcmp(s0, s1) == 0

#define times85(x)      ((((((x<<2)+x)<<2)+x)<<2)+x)

long int Ceor = 0;
long int Csum = 0;
long int Crot = 0;
long int word = 0;
long int bcount = 0;
long int line = 1;

fatal(s) 
   char *s;
{
  fprintf(stderr, "atob: error -- %s line %d after header\n", s, line);
  exit(1);
}

#define DE(c) ((c) - '!')

decode(c) 
  reg c;
{
  char errbuf[128];

  if (c == 'z') {
    if (bcount != 0) {
      fatal("alignment error");
    } else {
      byteout(0);
      byteout(0);
      byteout(0);
      byteout(0);
    }
  } else if ((c >= '!') && (c < ('!' + 85))) {
    if (bcount == 0) {
      word = DE(c);
      ++bcount;
    } else if (bcount < 4) {
      word = times85(word);
      word += DE(c);
      ++bcount;
    } else {
      word = times85(word) + DE(c);
      byteout((int)((word >> 24) & 255));
      byteout((int)((word >> 16) & 255));
      byteout((int)((word >> 8) & 255));
      byteout((int)(word & 255));
      word = 0;
      bcount = 0;
    }
  } else {
    sprintf(errbuf, "invalid character %d", c);
    fatal(errbuf);
  }
}

FILE *tmp_file;

byteout(c) 
  reg c;
{
  Ceor ^= c;
  Csum += c;
  Csum += 1;
  if ((Crot & 0x80000000)) {
    Crot <<= 1;
    Crot += 1;
  } else {
    Crot <<= 1;
  }
  Crot += c;
  putc(c, tmp_file);
}

main(argc, argv) 
  char **argv;
{
  reg c;
  reg long int i;
  char tmp_name[100];
  char buf[100];
  long int n1, n2, oeor, osum, orot;

  if (argc != 1) {
    fprintf(stderr,"bad args to %s\n", argv[0]);
    exit(2);
  }
  sprintf(tmp_name, "/usr/tmp/atob.%x", getpid());
  tmp_file = fopen(tmp_name, "w+");
  if (tmp_file == NULL) {
    fatal("create of temp file failed");
  }
  unlink(tmp_name);     /* Make file disappear */
  /*search for header line*/
  for (;;) {
    if (fgets(buf, sizeof buf, stdin) == NULL) {
      fatal("no header found");
    }
    if (memcmp(buf, "xbtoa Begin", 11) == 0) {
      break;
    }
  }

  while ((c = getchar()) != EOF) {
    if (isspace(c)) {
      if (c == '\n') line++;
      continue;
    } else if (c == 'x') {
      break;
    } else {
      decode(c);
    }
  }
  if(scanf("btoa End N %ld %lx E %lx S %lx R %lx ",
         &n1, &n2, &oeor, &osum, &orot) != 5) {
    fatal("invalid trailer");
  }
  if (n1 != n2) {
    fatal("bad trialer bytecount");
  } else if (oeor != Ceor) {
    fatal("bad XOR check");
  } else if (osum != Csum) {
    fatal("bad check sum");
  } else if (orot != Crot) {
    fatal("bad rotate check");
  } else {
    /*copy OK tmp file to stdout*/;
    fseek(tmp_file, 0L, 0);
    for (i = n1; --i >= 0;) {
      putchar(getc(tmp_file));
    }
  }
  exit(0);
}
@EOF

chmod 644 atob.c

echo x - btoa.1
cat >btoa.1 <<'@EOF'
.TH BTOA 1 local
.SH NAME
btoa, atob, tarmail, untarmail \- encode/decode binary to printable ASCII
.SH SYNOPSIS
.B btoa
.br
.B atob
.br
.B tarmail
who subject files ...
.br
.B untarmail
[ file ]
.SH DESCRIPTION
.I Btoa
is a filter that reads anything from the standard input, and encodes it into
printable ASCII on the standard output.  It also attaches a header and checksum
information used by the reverse filter 
.I atob 
to find the start of the data and to check integrity.
.PP
.I Atob
reads an encoded file, strips off any leading and
trailing lines added by mailers, and recreates a copy of the original file
on the standard output.
.I Atob 
gives NO output (and exits with an error message) if its input is garbage or 
the checksums do not check.
.PP
.I Tarmail
is a shell script that tar's up all the given files, pipes them 
through 
.IR compress ","
.IR btoa ","
and mails them to the given person with the given subject phrase.  For
example:
.PP
.in 1i
tarmail ralph "here it is ralph" foo.c a.out
.in -1i
.PP
Will package up files "foo.c" and "a.out" and mail them to "ralph" using
subject "here it is ralph".  Notice the quotes on the subject.  They are
necessary to make it one argument to the shell.
.PP
.I Tarmail 
with no args will print a short message reminding you what the required args 
are.  When the mail is received at the other end, that person should use
mail to save the message in some temporary file name (say "xx").
Then saying "untarmail xx"
will decode the message and untar it.  
.I Untarmail 
can also be used as a filter.  By using 
.IR tarmail ","
binary files and
entire directory structures can be easily transmitted between machines.
Naturally, you should understand what tar itself does before you use 
.IR tarmail "."
.PP
Other uses:
.PP
compress < secrets | crypt | btoa | mail ralph
.PP
will mail the encrypted contents of the file "secrets" to ralph.  If ralph
knows the encryption key, he can decode it by saving the mail (say in "xx"),
and then running:
.PP
atob < xx | crypt | uncompress
.PP
(crypt requests the key from the terminal,
and the "secrets" come out on the terminal).
.SH AUTHOR
Paul Rutter (modified by Joe Orost)
.SH FEATURES
.I Btoa
uses a compact base-85 encoding so that
4 bytes are encoded into 5 characters (file is expanded by 25%).
As a special case, 32-bit zero is encoded as one character.  This encoding
produces less output than
.IR uuencode "(1)."
.SH "SEE ALSO"
compress(1), crypt(1), uuencode(1), mail(1)
@EOF

chmod 644 btoa.1

echo x - btoa.c
cat >btoa.c <<'@EOF'
/* btoa: version 4.0
 * stream filter to change 8 bit bytes into printable ascii
 * computes the number of bytes, and three kinds of simple checksums
 * incoming bytes are collected into 32-bit words, then printed in base 85
 *  exp(85,5) > exp(2,32)
 * the ASCII characters used are between '!' and 'u'
 * 'z' encodes 32-bit zero; 'x' is used to mark the end of encoded data.
 *
 *  Paul Rutter		Joe Orost
 *  philabs!per		petsd!joe
 *
 *  WARNING: this version is not compatible with the original as sent out
 *  on the net.  The original encoded from ' ' to 't'; which cause problems
 *  with some mailers (stripping off trailing blanks).
 */

#include <stdio.h>

#define reg register

#define MAXPERLINE 78

long int Ceor = 0;
long int Csum = 0;
long int Crot = 0;

long int ccount = 0;
long int bcount = 0;
long int word;

#define EN(c)	(int) ((c) + '!')

encode(c) 
  reg c;
{
  Ceor ^= c;
  Csum += c;
  Csum += 1;
  if ((Crot & 0x80000000)) {
    Crot <<= 1;
    Crot += 1;
  } else {
    Crot <<= 1;
  }
  Crot += c;

  word <<= 8;
  word |= c;
  if (bcount == 3) {
    wordout(word);
    bcount = 0;
  } else {
    bcount += 1;
  }
}

wordout(word) 
  reg long int word;
{
  if (word == 0) {
    charout('z');
  } else {
    reg int tmp = 0;
    
    if(word < 0) {	/* Because some don't support unsigned long */
      tmp = 32;
      word = word - ((long)85 * 85 * 85 * 85 * 32);
    }
    if(word < 0) {
      tmp = 64;
      word = word - ((long)85 * 85 * 85 * 85 * 32);
    }
    charout(EN((word / ((long)85 * 85 * 85 * 85)) + tmp));
    word %= ((long)85 * 85 * 85 * 85);
    charout(EN(word / ((long)85 * 85 * 85)));
    word %= ((long)85 * 85 * 85);
    charout(EN(word / (85 * 85)));
    word %= (85 * 85);
    charout(EN(word / 85));
    word %= 85;
    charout(EN(word));
  }
}

charout(c) {
  putchar(c);
  ccount += 1;
  if (ccount == MAXPERLINE) {
    putchar('\n');
    ccount = 0;
  }
}

main(argc,argv) 
  char **argv;
{
  reg c;
  reg long int n;

  if (argc != 1) {
    fprintf(stderr,"bad args to %s\n", argv[0]);
    exit(2);
  }
  printf("xbtoa Begin\n");
  n = 0;
  while ((c = getchar()) != EOF) {
    encode(c);
    n += 1;
  }
  while (bcount != 0) {
    encode(0);
  }
  /* n is written twice as crude cross check*/
  printf("\nxbtoa End N %ld %lx E %lx S %lx R %lx\n", n, n, Ceor, Csum, Crot);
  exit(0);
}
@EOF

chmod 644 btoa.c

rm /tmp/unpack$$
exit 0

